import javax.swing.event.*;
import javax.swing.*;
import java.awt.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.util.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class AddDataSource extends JDialog implements ListSelectionListener {
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  JPanel jPanel2 = new JPanel();
  JSplitPane jSplitPane1 = new JSplitPane();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout3 = new BorderLayout();
  JList modelList = new JList();
  BorderLayout borderLayout4 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JList dsList = new JList();
  MainWindow mainWindow;
  DataSource[] selected = null;

  public AddDataSource(MainWindow mw) throws HeadlessException {
    mainWindow  = mw;
    try {
      jbInit();
      generateModelList ();
      setSize (400, 250);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void generateModelList () {
    modelList.setListData(mainWindow.getModels());
  }

  public void valueChanged (ListSelectionEvent e) {
    MRM selected = (MRM)modelList.getSelectedValue();
    MRMAnalyser analyser = mainWindow.getAnalyser(selected);
    Vector dss = new Vector ();
    if (analyser!=null) {
      DataSeries[] ds = analyser.getDataSeries();
      for (int i=0; i<ds.length; i++) {
        String dsname = ds[i].label.getText();
        for (int j=0; j<ds[i].ylabels.length; j++) {
          DataSource dataSource = new DataSource (ds[i], j);
          dss.add (dataSource);
        }
      }
    }
    dsList.setListData(dss);
  }

  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border1,"Models");
    border2 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder2 = new TitledBorder(border2,"Data Series");
    this.setModal(true);
    this.setTitle("Add Data Source");
    this.getContentPane().setLayout(borderLayout1);
    ok.setText("OK");
    ok.addActionListener(new AddDataSource_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new AddDataSource_cancel_actionAdapter(this));
    jPanel2.setLayout(borderLayout2);
    jPanel3.setBorder(titledBorder1);
    jPanel3.setLayout(borderLayout3);
    jPanel4.setBorder(titledBorder2);
    jPanel4.setLayout(borderLayout4);
    modelList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    jPanel1.add(cancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jSplitPane1,  BorderLayout.CENTER);
    jSplitPane1.add(jPanel3, JSplitPane.LEFT);
    jPanel3.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(modelList, null);
    jSplitPane1.add(jPanel4, JSplitPane.RIGHT);
    jPanel4.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(dsList, null);
    jSplitPane1.setDividerLocation(150);
    modelList.addListSelectionListener(this);
  }

  void ok_actionPerformed(ActionEvent e) {
    Object[] selection = dsList.getSelectedValues();
    selected = new DataSource[selection.length];
    for (int i=0; i<selected.length; i++)
      selected[i] = (DataSource)selection[i];
    setVisible (false);
  }

  void cancel_actionPerformed(ActionEvent e) {
    selected = null;
    setVisible (false);
  }

}

class AddDataSource_ok_actionAdapter implements java.awt.event.ActionListener {
  AddDataSource adaptee;

  AddDataSource_ok_actionAdapter(AddDataSource adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class AddDataSource_cancel_actionAdapter implements java.awt.event.ActionListener {
  AddDataSource adaptee;

  AddDataSource_cancel_actionAdapter(AddDataSource adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
