
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.io.*;
import java.util.*;
import javax.swing.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class ApproxDistrib extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField lower = new JTextField();
  JLabel jLabel2 = new JLabel();
  JTextField upper = new JTextField();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JLabel jLabel3 = new JLabel();
  JSpinner numofmoms = new JSpinner();
  JPanel jPanel6 = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  JPanel jPanel7 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JLabel jLabel4 = new JLabel();
  JTextField from = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField to = new JTextField();
  JLabel jLabel6 = new JLabel();
  JTextField steps = new JTextField();
  JPanel jPanel8 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JPanel jPanel9 = new JPanel();
  JLabel jLabel7 = new JLabel();
  JTextField label = new JTextField();
  BorderLayout borderLayout6 = new BorderLayout();
  MRMAnalyser myMRMA;
  DataSeries myDS;
  int maxMom;
  double xval;
  double[] moments;

  public ApproxDistrib(MRMAnalyser myMRMA, DataSeries active) throws HeadlessException {
    this.myMRMA = myMRMA;
    myDS = active;
    try {
      jbInit();

      int row = active.table.getSelectedRow();
      DataItem di = (DataItem)active.items.elementAt(row);
      xval = di.xval;
      moments = new double[myDS.cols];
      for (int i=0; i<myDS.cols; i++)
        moments[i] = di.yvals[i];
      lower.setText(Double.toString(di.opt1));
      lower.setCaretPosition(0);
      upper.setText(Double.toString(di.opt2));
      upper.setCaretPosition(0);
      maxMom = myDS.cols;
      numofmoms.setValue(new Integer(myDS.cols));
      from.setText("0");
//      from.setText(lower.getText());
      from.setCaretPosition(0);
      to.setText(Double.toString(moments[1]*2));
//      to.setText(upper.getText());
      to.setCaretPosition(0);
      label.setText("Estimation of the "+myDS.quantity+" at "+ xval+" using "+numofmoms.getValue().toString()+" moments");
      label.setCaretPosition(0);
      setSize (350,210);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    border1 = BorderFactory.createEmptyBorder();
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(142, 142, 142)),"Time points:");
    this.setModal(true);
    this.setResizable(true);
    this.setTitle("Distribution Estimation");
    this.getContentPane().setLayout(borderLayout1);
    ok.setText("OK");
    ok.addActionListener(new ApproxDistrib_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new ApproxDistrib_cancel_actionAdapter(this));
    jPanel2.setLayout(borderLayout2);
    jLabel1.setText("Lower bound:");
    lower.setText("");
    lower.setColumns(5);
    jLabel2.setText("Upper bound:");
    upper.setText("");
    upper.setColumns(5);
    jPanel4.setLayout(borderLayout3);
    jLabel3.setText("Number of Moments to use:");
    numofmoms.setMaximumSize(new Dimension(32767, 32767));
    numofmoms.setMinimumSize(new Dimension(96, 20));
    numofmoms.setPreferredSize(new Dimension(96, 20));
    numofmoms.addChangeListener(new ApproxDistrib_numofmoms_changeAdapter(this));
    jPanel6.setBorder(titledBorder1);
    jPanel6.setLayout(borderLayout4);
    jLabel4.setText("From:");
    from.setText("");
    from.setColumns(4);
    jLabel5.setText("To:");
    to.setText("");
    to.setColumns(4);
    jLabel6.setText("Steps:");
    steps.setText("21");
    steps.setColumns(4);
    jPanel8.setLayout(borderLayout5);
    jLabel7.setText("Label:");
    jPanel9.setLayout(borderLayout6);
    label.setText("");
    borderLayout6.setHgap(4);
    borderLayout1.setHgap(4);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    jPanel1.add(cancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jLabel1, null);
    jPanel3.add(lower, null);
    jPanel2.add(jPanel4, BorderLayout.CENTER);
    jPanel3.add(jLabel2, null);
    jPanel3.add(upper, null);
    jPanel4.add(jPanel5,  BorderLayout.NORTH);
    jPanel5.add(jLabel3, null);
    jPanel5.add(numofmoms, null);
    jPanel7.add(jLabel4, null);
    jPanel7.add(from, null);
    jPanel7.add(jLabel5, null);
    jPanel7.add(to, null);
    jPanel7.add(jLabel6, null);
    jPanel7.add(steps, null);
    jPanel4.add(jPanel8, BorderLayout.CENTER);
    jPanel8.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jPanel7, BorderLayout.CENTER);
    jPanel8.add(jPanel9,  BorderLayout.SOUTH);
    jPanel9.add(jLabel7, BorderLayout.WEST);
    jPanel9.add(label, BorderLayout.CENTER);
  }

  void ok_actionPerformed(ActionEvent e) {

    String error = "'From'";
    try {
      double vfrom = Double.parseDouble(from.getText());
      error = "'To'";
      double vto = Double.parseDouble(to.getText());
      error = "'Steps'";
      double vsteps = Double.parseDouble(steps.getText());
      error = "'Upper bound'";
      double vupper = Double.parseDouble(upper.getText());
      error = "'Lower bound'";
      double vlower = Double.parseDouble(lower.getText());
      error = "'Number of moments'";
      int num =  Integer.parseInt(numofmoms.getValue().toString());

      String common = ""+vlower+" "+vupper;
      for (int i=0; i<num; i++)
        common += " " + moments[i];

      try {
        PrintStream infile = new PrintStream (new FileOutputStream("tmp/estdistr.in"));
        for (int i=0; i<vsteps; i++)
          infile.println("" + (vfrom + i * (vto-vfrom) / (vsteps-1)) + " " + common);
        infile.close();
        Process process = Runtime.getRuntime().exec("bin/distributionestimation tmp/estdistr.in tmp/estdistr.out");
        process.waitFor ();


        String[] ylabels = new String [4];
        ylabels[0] = "cdf (upper)";
        ylabels[1] = "cdf (lower)";
        ylabels[2] = "ccdf (upper)";
        ylabels[3] = "ccdf (lower)";

        MRMParameterSet ps = new MRMParameterSet ();
        ps.addParameter(new Parameter (myDS.running, xval));
        for (int i=0; i<myDS.usedPS.parameters.size(); i++) {
          Parameter p = (Parameter)(myDS.usedPS.parameters.elementAt(i));
          ps.addParameter (new Parameter (p.name, p.value));
        }
        DataSeries ds = new DataSeries (ps, label.getText(), myDS.quantity, ylabels);
        ds.quantity = myDS.quantity;
        ds.momentType = false;
        ds.label.setText(label.getText());
        ds.modelString = myDS.modelString;
        BufferedReader outfile = new BufferedReader (new FileReader ("tmp/estdistr.out"));
        for (int i=0; i<vsteps; i++) {
          String line = outfile.readLine();
          StringTokenizer stk = new StringTokenizer (line, " \t\n");
          double x = Double.parseDouble(stk.nextToken());
          double[] y = new double[4];
          y[0] = Double.parseDouble(stk.nextToken());
          y[1] = Double.parseDouble(stk.nextToken());
          y[2] = Double.parseDouble(stk.nextToken());
          y[3] = Double.parseDouble(stk.nextToken());
          ds.addItem(x, y);
        }
        ds.changing = false;
        myMRMA.addDataSeries(ds);

        outfile.close();
        setVisible (false);
      }
      catch (IOException ex) {
        JOptionPane.showMessageDialog(this, "Cannot open file!\n"+ex.toString(), "Error!", JOptionPane.ERROR_MESSAGE);
      }
      catch (InterruptedException ex2) {
        JOptionPane.showMessageDialog(this, "Error executing distribution estimator!\n"+ex2.toString(), "Error!", JOptionPane.ERROR_MESSAGE);
      }

    }
    catch (NumberFormatException ex) {
      JOptionPane.showMessageDialog(this, "Invalid number format ("+error+")!\n"+ex.toString(), "Error!", JOptionPane.ERROR_MESSAGE);
    }
  }

  void cancel_actionPerformed(ActionEvent e) {
    setVisible (false);
  }


  void numofmoms_stateChanged(ChangeEvent e) {
    if (((Integer)numofmoms.getValue()).intValue()>maxMom) {
     numofmoms.setValue(new Integer(maxMom));
    }
    else if (((Integer)numofmoms.getValue()).intValue()<2) {
      numofmoms.setValue(new Integer(2));
    }
    else {
      label.setText("Estimation of the "+myDS.quantity+" at "+ xval+" using "+numofmoms.getValue().toString()+" moments");
      label.setCaretPosition(0);
    }
  }

}

class ApproxDistrib_ok_actionAdapter implements java.awt.event.ActionListener {
  ApproxDistrib adaptee;

  ApproxDistrib_ok_actionAdapter(ApproxDistrib adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class ApproxDistrib_cancel_actionAdapter implements java.awt.event.ActionListener {
  ApproxDistrib adaptee;

  ApproxDistrib_cancel_actionAdapter(ApproxDistrib adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class ApproxDistrib_numofmoms_changeAdapter implements javax.swing.event.ChangeListener {
  ApproxDistrib adaptee;

  ApproxDistrib_numofmoms_changeAdapter(ApproxDistrib adaptee) {
    this.adaptee = adaptee;
  }
  public void stateChanged(ChangeEvent e) {
    adaptee.numofmoms_stateChanged(e);
  }
}
