
import javax.swing.*;
import java.awt.*;
import java.util.*;
import java.awt.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class AskMRMType extends JDialog {
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  JLabel jLabel1 = new JLabel();
  JList mrmTypeList = new JList();
  MRMType selected = null;

  public AskMRMType(Vector types) throws HeadlessException {
    try {
      jbInit();
      mrmTypeList.setListData(types);
      mrmTypeList.setSelectedIndex(0);
      setSize (250,250);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setModal(true);
    this.setTitle("Select MRM Type");
    this.getContentPane().setLayout(borderLayout1);
    ok.setText("OK");
    ok.addActionListener(new AskMRMType_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new AskMRMType_cancel_actionAdapter(this));
    jLabel1.setText("MRM Type:");
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1,  BorderLayout.NORTH);
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(ok, null);
    jPanel2.add(cancel, null);
    jPanel1.add(jLabel1, null);
    jScrollPane1.getViewport().add(mrmTypeList, null);
  }

  void ok_actionPerformed(ActionEvent e) {
    if (mrmTypeList.isSelectionEmpty()==false)
      selected = (MRMType)mrmTypeList.getSelectedValue();
    setVisible (false);
  }

  void cancel_actionPerformed(ActionEvent e) {
    setVisible (false);
  }

}

class AskMRMType_ok_actionAdapter implements java.awt.event.ActionListener {
  AskMRMType adaptee;

  AskMRMType_ok_actionAdapter(AskMRMType adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class AskMRMType_cancel_actionAdapter implements java.awt.event.ActionListener {
  AskMRMType adaptee;

  AskMRMType_cancel_actionAdapter(AskMRMType adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
