

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class ColorChanger {

  public static final int BG = 0;
  public static final int TEXT = 1;
  public static final int TABLE1 = 2;
  public static final int TABLE2 = 3;

  static String [][] icolors;

  static Option color;


  public static String changeColor (String in) {

    String[] c =  icolors[(((Integer)(color.getValue())).intValue())];

    String res = in.replaceAll("%BG%", c[BG]);
    res = res.replaceAll("%TEXT%", c[TEXT]);
    res = res.replaceAll("%TABLE1%", c[TABLE1]);
    res = res.replaceAll("%TABLE2%", c[TABLE2]);

    return res;
  }

  public ColorChanger() {

    color = new Option ("Colors of Info Dialogs", Option.CHOICE, new Integer (0));

    String[] colors = new String [6];
    colors[0] = "Gray";
    colors[1] = "Yellow";
    colors[2] = "Red";
    colors[3] = "Green";
    colors[4] = "Blue";
    colors[5] = "Pink (dangerous!)";

    icolors = new String[6][];
    icolors[0] = new String[4];
    icolors[0][BG] = "#aaaaaa";
    icolors[0][TEXT] = "#000000";
    icolors[0][TABLE1] = "#cccccc";
    icolors[0][TABLE2] = "#eeeeee";

    icolors[1] = new String[4];
    icolors[1][BG] = "#ffff00";
    icolors[1][TEXT] = "#000000";
    icolors[1][TABLE1] = "#EEEE77";
    icolors[1][TABLE2] = "#FFFF77";

    icolors[2] = new String[4];
    icolors[2][BG] = "#ff2222";
    icolors[2][TEXT] = "#000000";
    icolors[2][TABLE1] = "#cc2222";
    icolors[2][TABLE2] = "#ee2222";

    icolors[3] = new String[4];
    icolors[3][BG] = "#22ff22";
    icolors[3][TEXT] = "#000000";
    icolors[3][TABLE1] = "#22cc22";
    icolors[3][TABLE2] = "#22ee22";

    icolors[4] = new String[4];
    icolors[4][BG] = "#7777ff";
    icolors[4][TEXT] = "#000000";
    icolors[4][TABLE1] = "#5555cc";
    icolors[4][TABLE2] = "#6666ff";

    icolors[5] = new String[4];
    icolors[5][BG] = "#ffbbbb";
    icolors[5][TEXT] = "#000000";
    icolors[5][TABLE1] = "#ffdddd";
    icolors[5][TABLE2] = "#ff9999";

    color.addChoice(colors);
//    algo.addDescription("<html><body bgcolor=#ffff00><h2>Algorithm</h2>The algorithm used by the prs mrm solver. <b>Randomization</b> is usualy the fastest,"+
//                        "but different <b>ODE</b> solvers can be selected, too. The selected algorithm can be fine tuned by the options below.</body></html>");

  }

}
