import java.io.*;
import javax.swing.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class CommandRunner extends Thread {

  String commandLine;
  public boolean running = false;
  public boolean aborted = false;
  public Process p = null;
  BufferedReader br = null;
  public String out = "";
  public String err = "";
  public StreamGobbler errorGobbler = null;
  public StreamGobbler outputGobbler = null;
  public int exitVal = 0;

  public CommandRunner (String cl) {
    commandLine = cl;
    running = false;
  }

  public void run () {
      err = "";
      out = "";
      aborted = false;
      try {
        p = Runtime.getRuntime().exec(commandLine);
        running = true;
        errorGobbler = new StreamGobbler(p.getErrorStream(), err);
        outputGobbler = new StreamGobbler(p.getInputStream(), out);
        errorGobbler.start();
        outputGobbler.start();
        exitVal = p.waitFor();
        running = false;
      }
      catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex.toString(),"Cannot execute "+commandLine+"!", JOptionPane.ERROR_MESSAGE);
      }
      catch (InterruptedException ex2) {
        System.out.println("commandrunner interrupted!");
        JOptionPane.showMessageDialog(null, ex2.toString(),"Cannot execute "+commandLine+"!", JOptionPane.ERROR_MESSAGE);
      }

  }

  public void abort () {
    p.destroy();
    aborted = true;
  }
}

class StreamGobbler extends Thread
{
  InputStream is;
  public String s;

  StreamGobbler(InputStream is, String s) {
    this.is = is;
    this.s = s;
  }

  public void run() {
    try
    {
      InputStreamReader isr = new InputStreamReader(is);
      BufferedReader br = new BufferedReader(isr);
      String line=null;
      while ( (line = br.readLine()) != null)
        s += line+"\n";
    } catch (IOException ioe) {
      ioe.printStackTrace();
    }
  }
}
