import java.io.*;
import java.util.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class DataSource {

  Boolean enabled = new Boolean(true);
  String legend = "";
  String name = "";
  double[] xval = null;
  double[] yval = null;

  public DataSource (DataSeries ds, int index) {

    xval = new double[ds.dm.getRowCount()];
    yval = new double[ds.dm.getRowCount()];

    for (int j = 0; j < ds.dm.getRowCount(); j++) {
      xval[j] = Double.parseDouble(ds.dm.getValueAt(j, 0).toString());
      yval[j] = Double.parseDouble(ds.dm.getValueAt(j, index+1).toString());
    }

    legend = ds.ylabels[index];
    name = ds.parent.model.getName() + "; " + ds.ylabels[index] + " @ " + ds.label.getText();
  }

  public DataSource () {

  }

  public String getlabel () {
//    if (series!=null)
//      return modelname + "; " + series.ylabels[index] + " @ " + series.label.getText();
//    else
//      return "field "+index+" @ " + modelname;
    return name;
  }

  public StringBuffer content () {
    StringBuffer content = new StringBuffer ();
//    if (series!=null)
//      for (int j = 0; j < series.dm.getRowCount(); j++)
//        content.append(series.dm.getValueAt(j, 0) + "\t" +
//                       series.dm.getValueAt(j, index + 1) + "\n");
//    else
      for (int j = 0; j < yval.length; j++)
        content.append(""+xval[j] + "\t" + yval[j] + "\n");
    return content;
  }

  public String toString () {
//    if (series!=null)
//      return series.ylabels[index] + " @ " + series.label.getText();
//    else
//      return "field "+index+" @ " + modelname;
    return name;
  }

  public StringBuffer exportString () {
    StringBuffer estring = new StringBuffer ("$$ DataSource legend=\""+legend+"\" name=\""+name+"\" visible="+enabled.toString()+"\n");
    estring.append(content());
    return estring;
  }
}
