
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class DiagOptions extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JTextField plotTitle = new JTextField();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel4 = new JPanel();
  JLabel jLabel2 = new JLabel();
  BorderLayout borderLayout4 = new BorderLayout();
  JTextField xAxisTitle = new JTextField();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  JLabel jLabel3 = new JLabel();
  BorderLayout borderLayout6 = new BorderLayout();
  JTextField yAxisTitle = new JTextField();
  JPanel jPanel7 = new JPanel();
  BorderLayout borderLayout7 = new BorderLayout();
  Border border1;
  BorderLayout borderLayout8 = new BorderLayout();
  JPanel jPanel8 = new JPanel();
  JPanel jPanel9 = new JPanel();
  JLabel jLabel4 = new JLabel();
  BorderLayout borderLayout9 = new BorderLayout();
  JComboBox lineStyle = new JComboBox();
  JPanel jPanel10 = new JPanel();
  BorderLayout borderLayout10 = new BorderLayout();
  Border border2;
  TitledBorder titledBorder1;
  BorderLayout borderLayout11 = new BorderLayout();
  JCheckBox showLegend = new JCheckBox();
  JPanel jPanel11 = new JPanel();
  BorderLayout borderLayout12 = new BorderLayout();
  JCheckBox drawLegendBox = new JCheckBox();
  JPanel jPanel12 = new JPanel();
  JPanel jPanel13 = new JPanel();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  Border border3;
  TitledBorder titledBorder2;
  BorderLayout borderLayout13 = new BorderLayout();
  JPanel jPanel14 = new JPanel();
  BorderLayout borderLayout14 = new BorderLayout();
  JRadioButton preDefinedBox = new JRadioButton();
  JComboBox boxPosition = new JComboBox();
  JPanel jPanel15 = new JPanel();
  BorderLayout borderLayout15 = new BorderLayout();
  JPanel jPanel16 = new JPanel();
  BorderLayout borderLayout16 = new BorderLayout();
  JRadioButton customBox = new JRadioButton();
  JPanel jPanel17 = new JPanel();
  BorderLayout borderLayout17 = new BorderLayout();
  JTextField xBoxPos = new JTextField();
  JPanel jPanel18 = new JPanel();
  BorderLayout borderLayout18 = new BorderLayout();
  JLabel jLabel5 = new JLabel();
  JPanel jPanel19 = new JPanel();
  JTextField yBoxPos = new JTextField();
  BorderLayout borderLayout19 = new BorderLayout();
  ButtonGroup buttonGroup1 = new ButtonGroup();

  String linestyle = "w lp";
  String plottitle = "";
  String xaxistitle = "";
  String yaxistitle = "";
  boolean showlegend = true;
  boolean showbox = false;
  String bottom = "";
  String top = "top";
  String left = "";
  String right = "right";
  String below = "";
  String outside = "";
  boolean custompos = false;
  String xpos = "";
  String ypos = "";

  public DiagOptions() throws HeadlessException {
    try {
      jbInit();

      setSize (300, 335);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);

      lineStyle.addItem ("Lines");
      lineStyle.addItem ("Points");
      lineStyle.addItem ("Lines & Points");
      boxPosition.addItem("Top Right");
      boxPosition.addItem("Top Left");
      boxPosition.addItem("Bottom Right");
      boxPosition.addItem("Bottom Left");
      boxPosition.addItem("Below");
      boxPosition.addItem("Outside Top");
      boxPosition.addItem("Outside Bottom");

      initGUI ();

    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void initGUI () {
    plotTitle.setText(plottitle);
    xAxisTitle.setText(xaxistitle);
    yAxisTitle.setText(yaxistitle);
    if (linestyle.equals("w l"))
      lineStyle.setSelectedIndex(0);
    else if (linestyle.equals("w p"))
      lineStyle.setSelectedIndex(1);
    else if (linestyle.equals("w lp"))
      lineStyle.setSelectedIndex(2);
    showLegend.setSelected(showlegend);
    drawLegendBox.setSelected(showbox);
    customBox.setSelected(custompos);
    preDefinedBox.setSelected(!custompos);
    xBoxPos.setText(xpos);
    yBoxPos.setText(ypos);
    if (below.length()>0)
      boxPosition.setSelectedIndex(4);
    else if (outside.length()>0) {
      if (top.length()>0)
        boxPosition.setSelectedIndex(5);
      else
        boxPosition.setSelectedIndex(6);
    }
    else if (top.length()>0) {
      if (right.length()>0)
        boxPosition.setSelectedIndex(0);
      else
        boxPosition.setSelectedIndex(1);
    }
    else {
      if (right.length()>0)
        boxPosition.setSelectedIndex(2);
      else
        boxPosition.setSelectedIndex(3);
    }
    enablePosPanel ();
  }

  public void enablePosPanel () {

    if (customBox.isSelected()) {
      boxPosition.setEnabled(false);
      xBoxPos.setEnabled(true);
      yBoxPos.setEnabled(true);
    }
    else {
      boxPosition.setEnabled(true);
      xBoxPos.setEnabled(false);
      yBoxPos.setEnabled(false);
    }
  }

  public void applyChanges () {

    plottitle = plotTitle.getText();
    xaxistitle = xAxisTitle.getText();
    yaxistitle = yAxisTitle.getText();
    int ls = lineStyle.getSelectedIndex();
    switch (ls) {
      case 0:
        linestyle = "w l";
        break;
      case 1:
        linestyle = "w p";
        break;
      case 2:
        linestyle = "w lp";
    }
    showlegend = showLegend.isSelected();
    showbox = drawLegendBox.isSelected();
    custompos = customBox.isSelected();
    xpos = xBoxPos.getText();
    ypos = yBoxPos.getText();
    int pos = boxPosition.getSelectedIndex();
    bottom = "";
    top = "";
    left = "";
    right = "";
    below = "";
    outside = "";

    switch (pos) {
      case 0:
        top = "top";
        right = "right";
        break;
      case 1:
        top = "top";
        left = "left";
        break;
      case 2:
        bottom = "bottom";
        right = "right";
        break;
      case 3:
        bottom = "bottom";
        left = "left";
        break;
      case 4:
        below = "below";
        break;
      case 5:
        outside = "outside";
        top = "top";
        break;
      case 6:
        outside = "outside";
        bottom = "bottom";
        break;
    }
  }

  public String getScriptLines () {

    String scr = "";
    if (plottitle.length()>0)
      scr += "set title '"+plottitle+"'\n";
    if (xaxistitle.length()>0)
      scr += "set xlabel '"+xaxistitle+"'\n";
    if (yaxistitle.length()>0)
      scr += "set ylabel '"+yaxistitle+"'\n";
    if (showlegend) {
      if (!custompos)
        scr += "set key " + left + " " + right + " " + bottom + " " + top + " " + outside + " " + below;
      else
        scr += "set key " + xpos + ", " + ypos;
      if (showbox)
        scr += " box";
      scr += "\n";
    }
    else {
      scr += "set nokey\n";
    }
    return scr;
  }

  private void jbInit() throws Exception {
    border1 = BorderFactory.createEmptyBorder(4,4,4,4);
    border2 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(156, 156, 158));
    titledBorder1 = new TitledBorder(border2,"Legend");
    border3 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(156, 156, 158));
    titledBorder2 = new TitledBorder(border3,"Position");
    this.setModal(true);
    this.setTitle("Plot Options");
    this.addWindowListener(new DiagOptions_this_windowAdapter(this));
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(borderLayout2);
    jLabel1.setText("Plot Title:");
    borderLayout2.setHgap(4);
    borderLayout2.setVgap(4);
    borderLayout1.setHgap(4);
    borderLayout1.setVgap(4);
    jPanel2.setLayout(borderLayout3);
    jLabel2.setText("X Axis Title:");
    jPanel3.setLayout(borderLayout4);
    borderLayout3.setHgap(4);
    borderLayout3.setVgap(4);
    borderLayout4.setHgap(4);
    borderLayout4.setVgap(4);
    jPanel4.setLayout(borderLayout5);
    jLabel3.setText("Y Axis Title:");
    jPanel5.setLayout(borderLayout6);
    borderLayout6.setHgap(4);
    borderLayout6.setVgap(4);
    jPanel7.setLayout(borderLayout7);
    borderLayout7.setHgap(4);
    borderLayout7.setVgap(4);
    jPanel7.setBorder(border1);
    jPanel6.setLayout(borderLayout8);
    jLabel4.setText("Line Style:");
    jPanel8.setLayout(borderLayout9);
    borderLayout9.setHgap(4);
    borderLayout9.setVgap(4);
    borderLayout8.setHgap(4);
    borderLayout8.setVgap(4);
    borderLayout5.setHgap(4);
    borderLayout5.setVgap(4);
    jPanel9.setLayout(borderLayout10);
    jPanel10.setBorder(titledBorder1);
    jPanel10.setLayout(borderLayout11);
    showLegend.setSelected(true);
    showLegend.setText("Show Legend");
    jPanel11.setLayout(borderLayout12);
    drawLegendBox.setText("Draw Bounding Box");
    ok.setText("OK");
    ok.addActionListener(new DiagOptions_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new DiagOptions_cancel_actionAdapter(this));
    jPanel12.setBorder(titledBorder2);
    jPanel12.setLayout(borderLayout13);
    jPanel14.setLayout(borderLayout14);
    preDefinedBox.setSelected(true);
    preDefinedBox.setText("Pre-Defined:");
    preDefinedBox.addItemListener(new DiagOptions_preDefinedBox_itemAdapter(this));
    jPanel15.setLayout(borderLayout15);
    jPanel16.setLayout(borderLayout16);
    customBox.setText("Custom:  X=");
    customBox.addItemListener(new DiagOptions_customBox_itemAdapter(this));
    jPanel17.setLayout(borderLayout17);
    xBoxPos.setEnabled(false);
    xBoxPos.setText("");
    xBoxPos.setColumns(5);
    jPanel18.setLayout(borderLayout18);
    jLabel5.setText("Y=");
    jPanel19.setLayout(borderLayout19);
    borderLayout16.setHgap(4);
    borderLayout16.setVgap(4);
    borderLayout15.setHgap(4);
    borderLayout15.setVgap(4);
    borderLayout13.setHgap(4);
    borderLayout13.setVgap(4);
    borderLayout17.setHgap(4);
    borderLayout17.setVgap(4);
    borderLayout18.setHgap(4);
    borderLayout18.setVgap(4);
    jPanel16.setAlignmentX((float) 0.5);
    plotTitle.setText("");
    xAxisTitle.setText("");
    yAxisTitle.setText("");
    yBoxPos.setEnabled(false);
    yBoxPos.setText("");
    yBoxPos.setColumns(5);
    jPanel1.add(jLabel1, BorderLayout.WEST);
    jPanel1.add(plotTitle, BorderLayout.CENTER);
    jPanel7.add(jPanel2, BorderLayout.CENTER);
    jPanel2.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jLabel2, BorderLayout.WEST);
    jPanel3.add(xAxisTitle, BorderLayout.CENTER);
    jPanel2.add(jPanel4, BorderLayout.CENTER);
    jPanel5.add(jLabel3,  BorderLayout.WEST);
    jPanel5.add(yAxisTitle, BorderLayout.CENTER);
    jPanel4.add(jPanel6, BorderLayout.CENTER);
    jPanel6.add(jPanel8, BorderLayout.NORTH);
    jPanel8.add(jLabel4,  BorderLayout.WEST);
    jPanel8.add(lineStyle, BorderLayout.CENTER);
    jPanel6.add(jPanel9,  BorderLayout.CENTER);
    jPanel9.add(jPanel10,  BorderLayout.NORTH);
    jPanel10.add(showLegend, BorderLayout.NORTH);
    jPanel10.add(jPanel11,  BorderLayout.CENTER);
    jPanel11.add(drawLegendBox, BorderLayout.NORTH);
    jPanel11.add(jPanel12,  BorderLayout.CENTER);
    jPanel7.add(jPanel13,  BorderLayout.SOUTH);
    jPanel13.add(ok, null);
    jPanel13.add(cancel, null);
    jPanel4.add(jPanel5, BorderLayout.NORTH);
    this.getContentPane().add(jPanel7,  BorderLayout.CENTER);
    jPanel7.add(jPanel1, BorderLayout.NORTH);
    jPanel12.add(jPanel14, BorderLayout.NORTH);
    jPanel14.add(preDefinedBox, BorderLayout.WEST);
    jPanel14.add(boxPosition, BorderLayout.CENTER);
    jPanel12.add(jPanel15, BorderLayout.CENTER);
    jPanel15.add(jPanel16,  BorderLayout.NORTH);
    jPanel16.add(customBox, BorderLayout.WEST);
    jPanel16.add(jPanel17,  BorderLayout.CENTER);
    jPanel17.add(xBoxPos, BorderLayout.WEST);
    jPanel17.add(jPanel18, BorderLayout.CENTER);
    jPanel18.add(jLabel5, BorderLayout.WEST);
    jPanel18.add(jPanel19, BorderLayout.CENTER);
    jPanel19.add(yBoxPos,  BorderLayout.WEST);
    buttonGroup1.add(preDefinedBox);
    buttonGroup1.add(customBox);
  }

  void ok_actionPerformed(ActionEvent e) {

    applyChanges ();
    setVisible (false);
  }

  void cancel_actionPerformed(ActionEvent e) {

    setVisible (false);
  }

  void this_windowOpened(WindowEvent e) {
    initGUI ();
  }

  void preDefinedBox_itemStateChanged(ItemEvent e) {
    enablePosPanel ();
  }

  void customBox_itemStateChanged(ItemEvent e) {
    enablePosPanel ();
  }

}

class DiagOptions_ok_actionAdapter implements java.awt.event.ActionListener {
  DiagOptions adaptee;

  DiagOptions_ok_actionAdapter(DiagOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class DiagOptions_cancel_actionAdapter implements java.awt.event.ActionListener {
  DiagOptions adaptee;

  DiagOptions_cancel_actionAdapter(DiagOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class DiagOptions_this_windowAdapter extends java.awt.event.WindowAdapter {
  DiagOptions adaptee;

  DiagOptions_this_windowAdapter(DiagOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void windowOpened(WindowEvent e) {
    adaptee.this_windowOpened(e);
  }
}

class DiagOptions_preDefinedBox_itemAdapter implements java.awt.event.ItemListener {
  DiagOptions adaptee;

  DiagOptions_preDefinedBox_itemAdapter(DiagOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.preDefinedBox_itemStateChanged(e);
  }
}

class DiagOptions_customBox_itemAdapter implements java.awt.event.ItemListener {
  DiagOptions adaptee;

  DiagOptions_customBox_itemAdapter(DiagOptions adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.customBox_itemStateChanged(e);
  }
}
