import javax.swing.table.*;
import javax.swing.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;
import java.util.*;
import java.io.*;
import javax.imageio.*;
import javax.imageio.stream.*;
import java.awt.image.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class DiagramEditor extends JInternalFrame {

  MainWindow mainWindow;
  DataSourceDataModel dsm = new DataSourceDataModel ();
  DiagOptions diagOptions = new DiagOptions ();

  JTable table = new JTable (dsm);
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel dataPanel = new JPanel();
  JPanel optionsPanel = new JPanel();
  JPanel diagramArea = new JPanel();
  Border border1;
  TitledBorder titledBorder1;
  Border border2;
  TitledBorder titledBorder2;
  Border border3;
  TitledBorder titledBorder3;
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton addDS = new JButton();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JButton removeDS = new JButton();
  BorderLayout borderLayout4 = new BorderLayout();
  Component spacer1 = Box.createVerticalStrut(48);
  JPanel jPanel3 = new JPanel();
  JScrollPane tableScroll = new JScrollPane(table);
  BorderLayout borderLayout5 = new BorderLayout();
  JButton moreOpt = new JButton();
  JPanel jPanel4 = new JPanel();
  Border border4;
  TitledBorder titledBorder4;
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout6 = new BorderLayout();
  JPanel jPanel6 = new JPanel();
  Border border5;
  TitledBorder titledBorder5;
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel7 = new JPanel();
  JCheckBox logX = new JCheckBox();
  BorderLayout borderLayout8 = new BorderLayout();
  JRadioButton autoX = new JRadioButton();
  Border border6;
  TitledBorder titledBorder6;
  JPanel jPanel8 = new JPanel();
  JRadioButton customX = new JRadioButton();
  BorderLayout borderLayout9 = new BorderLayout();
  JPanel jPanel9 = new JPanel();
  BorderLayout borderLayout10 = new BorderLayout();
  JTextField xFrom = new JTextField();
  JPanel jPanel10 = new JPanel();
  BorderLayout borderLayout11 = new BorderLayout();
  JLabel xToLabel = new JLabel();
  JPanel jPanel11 = new JPanel();
  BorderLayout borderLayout12 = new BorderLayout();
  JTextField xTo = new JTextField();
  BorderLayout borderLayout13 = new BorderLayout();
  JCheckBox logY = new JCheckBox();
  JPanel jPanel12 = new JPanel();
  Border border7;
  TitledBorder titledBorder7;
  JRadioButton autoY = new JRadioButton();
  BorderLayout borderLayout14 = new BorderLayout();
  JPanel jPanel13 = new JPanel();
  BorderLayout borderLayout15 = new BorderLayout();
  JRadioButton customY = new JRadioButton();
  JPanel jPanel14 = new JPanel();
  BorderLayout borderLayout16 = new BorderLayout();
  JTextField yFrom = new JTextField();
  JPanel jPanel15 = new JPanel();
  BorderLayout borderLayout17 = new BorderLayout();
  JLabel yToLabel = new JLabel();
  JTextField yTo = new JTextField();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  BorderLayout borderLayout18 = new BorderLayout();
  JPanel plotPanel = new JPanel();
  JPanel gpSourcePanel = new JPanel();
  JPanel gpDataPanel = new JPanel();
  BorderLayout borderLayout19 = new BorderLayout();
  JPanel jPanel16 = new JPanel();
  JButton redraw = new JButton();
  BorderLayout borderLayout20 = new BorderLayout();
  JPanel jPanel19 = new JPanel();
  BorderLayout borderLayout21 = new BorderLayout();
  JButton exportEPS = new JButton();
  JPanel jPanel20 = new JPanel();
  JButton exportSrc = new JButton();
  BorderLayout borderLayout22 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  BorderLayout borderLayout23 = new BorderLayout();
  JTextArea gpSrc = new JTextArea();
  BorderLayout borderLayout24 = new BorderLayout();
  JScrollPane jScrollPane2 = new JScrollPane();
  JTextArea gpData = new JTextArea();
  JLabel plot = new JLabel();
  ButtonGroup xrange = new ButtonGroup();
  ButtonGroup yrange = new ButtonGroup();
  JPanel jPanel17 = new JPanel();
  BorderLayout borderLayout25 = new BorderLayout();
  JButton load = new JButton();
  JPanel jPanel18 = new JPanel();
  BorderLayout borderLayout26 = new BorderLayout();
  JCheckBox xgrid = new JCheckBox();
  JPanel jPanel21 = new JPanel();
  BorderLayout borderLayout27 = new BorderLayout();
  JCheckBox ygrid = new JCheckBox();

  class DataSourceDataModel extends AbstractTableModel {

    Vector listeners = new Vector ();
    Vector data = new Vector ();

    public void addTableModelListener(TableModelListener l) {
      listeners.add(l);
    }

    public void refresh () {
      Iterator i = listeners.iterator();
      while (i.hasNext()) {
        TableModelListener tml = (TableModelListener)i.next();
        tml.tableChanged(new TableModelEvent(this));
      }
    }

    public void deleteRows (int[] rows) {
      Vector toDel = new Vector ();
      for (int i=0; i<rows.length; i++)
        toDel.add(data.elementAt(rows[i]));
      Iterator it = toDel.iterator();
      while (it.hasNext())
        data.remove(it.next());
    }

    public int getColumnCount() { return 3; }

    public int getRowCount() { return data.size(); }

    public Class getColumnClass(int c) {
        return getValueAt(0, c).getClass();
    }

    public Object getValueAt(int row, int col) {
      DataSource ds = (DataSource)data.elementAt(row);
      if (col==0)
        return ds.enabled;
      else if (col==1)
        return ds.legend;
      else
        return ds.getlabel();
    }

    public void setValueAt(Object val, int row, int col) {
      DataSource ds = (DataSource)data.elementAt(row);
      if (col==0)
        ds.enabled = (Boolean)val;
      else if (col==1)
        ds.legend = (String)val;
      redrawPlot ();
    }

    public String getColumnName (int i) {
      if (i==0)
        return "Visible";
      else if (i==1)
        return "Legend";
      else
        return "Data Source";
    }

    public boolean isCellEditable (int r, int c) {
      return c==0 || c==1;
    }
  }


  public DiagramEditor(MainWindow mw) {
    super("Diagram Editor",
              true, //resizable
              true, //closable
              true, //maximizable
              true);//iconifiable
    mainWindow = mw;
    try {
      jbInit();
      table.getColumnModel().getColumn(1).setMaxWidth(128);
      table.getColumnModel().getColumn(0).setMaxWidth(48);
      table.getColumnModel().getColumn(1).setPreferredWidth(128);
      setSize (650, 490);
      setLocation ((mw.desktop.getWidth()-getWidth())/2, (mw.desktop.getHeight()-getHeight())/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    tableScroll.setPreferredSize(new Dimension (50,100));
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border1,"Diagram");
    border2 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder2 = new TitledBorder(border2,"Data Source");
    border3 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder3 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140)),"Options");
    border4 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder4 = new TitledBorder(border4,"X Axis");
    border5 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder5 = new TitledBorder(border5,"Y axis");
    border6 = BorderFactory.createEmptyBorder();
    titledBorder6 = new TitledBorder(BorderFactory.createEmptyBorder(),"Range:");
    border7 = BorderFactory.createEmptyBorder();
    titledBorder7 = new TitledBorder(border7,"Range:");
    this.setTitle("Diagram Editor");
    this.addComponentListener(new DiagramEditor_this_componentAdapter(this));
    this.getContentPane().setLayout(borderLayout1);
    diagramArea.setBorder(titledBorder1);
    diagramArea.setLayout(borderLayout18);
    dataPanel.setAutoscrolls(false);
    dataPanel.setBorder(titledBorder2);
    dataPanel.setLayout(borderLayout2);
    optionsPanel.setBorder(titledBorder3);
    optionsPanel.setLayout(borderLayout5);
    addDS.setToolTipText("Add new curve to the diagram");
    addDS.setText("Add...");
    addDS.addActionListener(new DiagramEditor_addDS_actionAdapter(this));
    jPanel1.setLayout(borderLayout3);
    removeDS.setToolTipText("Remove selected curves from the list");
    removeDS.setText("Remove");
    removeDS.addActionListener(new DiagramEditor_removeDS_actionAdapter(this));
    jPanel2.setLayout(borderLayout4);
    moreOpt.setToolTipText("Change more options, like line style, label of axes and legend placement");
    moreOpt.setText("More Options...");
    moreOpt.addActionListener(new DiagramEditor_moreOpt_actionAdapter(this));
    jPanel4.setBorder(titledBorder4);
    jPanel4.setLayout(borderLayout7);
    jPanel5.setLayout(borderLayout6);
    jPanel6.setBorder(titledBorder5);
    jPanel6.setLayout(borderLayout13);
    logX.setText("Logscale");
    logX.addActionListener(new DiagramEditor_logX_actionAdapter(this));
    jPanel7.setLayout(borderLayout8);
    autoX.setToolTipText("");
    autoX.setSelected(true);
    autoX.setText("Auto");
    autoX.addItemListener(new DiagramEditor_autoX_itemAdapter(this));
    jPanel7.setBorder(titledBorder6);
    customX.setText("From");
    customX.addItemListener(new DiagramEditor_customX_itemAdapter(this));
    jPanel8.setLayout(borderLayout9);
    jPanel9.setLayout(borderLayout10);
    jPanel10.setLayout(borderLayout11);
    xToLabel.setEnabled(false);
    xToLabel.setText("to");
    jPanel11.setLayout(borderLayout12);
    xTo.setEnabled(false);
    xTo.setText("");
    xTo.setColumns(4);
    borderLayout10.setHgap(4);
    borderLayout11.setHgap(4);
    xFrom.setEnabled(false);
    xFrom.setCaretPosition(0);
    xFrom.setText("");
    xFrom.setColumns(4);
    logY.setText("Logscale");
    logY.addActionListener(new DiagramEditor_logY_actionAdapter(this));
    jPanel12.setBorder(titledBorder7);
    jPanel12.setLayout(borderLayout14);
    autoY.setSelected(true);
    autoY.setText("Auto");
    autoY.addItemListener(new DiagramEditor_autoY_itemAdapter(this));
    jPanel13.setLayout(borderLayout15);
    customY.setText("From");
    customY.addItemListener(new DiagramEditor_customY_itemAdapter(this));
    jPanel14.setLayout(borderLayout16);
    yFrom.setEnabled(false);
    yFrom.setText("");
    yFrom.setColumns(4);
    jPanel15.setLayout(borderLayout17);
    yToLabel.setEnabled(false);
    yToLabel.setText("to");
    yTo.setEnabled(false);
    yTo.setText("");
    yTo.setColumns(4);
    borderLayout15.setHgap(4);
    borderLayout16.setHgap(4);
    borderLayout17.setHgap(4);
    plotPanel.setLayout(borderLayout19);
    redraw.setToolTipText("Refresh plot");
    redraw.setText("Redraw");
    redraw.addActionListener(new DiagramEditor_redraw_actionAdapter(this));
    jPanel16.setLayout(borderLayout20);
    jPanel19.setLayout(borderLayout21);
    exportEPS.setToolTipText("Export plot to eps format");
    exportEPS.setText("Export EPS");
    exportEPS.addActionListener(new DiagramEditor_exportEPS_actionAdapter(this));
    exportSrc.setToolTipText("Export gnuplot source of the plot");
    exportSrc.setText("Export Source");
    exportSrc.addActionListener(new DiagramEditor_exportSrc_actionAdapter(this));
    jPanel20.setLayout(borderLayout22);
    gpSourcePanel.setName("");
    gpSourcePanel.setLayout(borderLayout23);
    gpSrc.setText("");
    gpDataPanel.setLayout(borderLayout24);
    gpData.setText("");
    jPanel2.setVisible(true);
    plot.setHorizontalAlignment(SwingConstants.CENTER);
    plot.setHorizontalTextPosition(SwingConstants.CENTER);
    jPanel17.setForeground(Color.black);
    jPanel17.setLayout(borderLayout25);
    load.setToolTipText("Import data from an external file");
    load.setText("Import...");
    load.addActionListener(new DiagramEditor_load_actionAdapter(this));
    jPanel18.setLayout(borderLayout26);
    xgrid.setText("Grid");
    xgrid.addActionListener(new DiagramEditor_xgrid_actionAdapter(this));
    jPanel21.setLayout(borderLayout27);
    ygrid.setText("Grid");
    ygrid.addActionListener(new DiagramEditor_ygrid_actionAdapter(this));
    this.getContentPane().add(dataPanel, BorderLayout.SOUTH);
    this.getContentPane().add(optionsPanel, BorderLayout.EAST);
    optionsPanel.add(jPanel3,  BorderLayout.SOUTH);
    this.getContentPane().add(diagramArea, BorderLayout.CENTER);
    diagramArea.add(jTabbedPane1,  BorderLayout.CENTER);
    jTabbedPane1.add(plotPanel,   "Graphical Plot");
    jTabbedPane1.add(gpSourcePanel,  "GNUPlot Source");
    jTabbedPane1.add(gpDataPanel,  "GNUPlot Data");
    dataPanel.add(jPanel1,  BorderLayout.EAST);
    jPanel1.add(addDS, BorderLayout.NORTH);
    jPanel1.add(jPanel2,  BorderLayout.CENTER);
    jPanel2.add(jPanel17, BorderLayout.CENTER);
    jPanel17.add(removeDS,  BorderLayout.NORTH);
    jPanel2.add(load, BorderLayout.NORTH);
//    jPanel2.add(spacer1, BorderLayout.CENTER);
    dataPanel.add(tableScroll, BorderLayout.CENTER);
    jPanel3.add(moreOpt, null);
    optionsPanel.add(jPanel4, BorderLayout.NORTH);
    jPanel4.add(jPanel7, BorderLayout.CENTER);
    jPanel4.add(jPanel18,  BorderLayout.SOUTH);
    jPanel18.add(logX,  BorderLayout.WEST);
    jPanel18.add(xgrid, BorderLayout.EAST);
    optionsPanel.add(jPanel5, BorderLayout.CENTER);
    jPanel5.add(jPanel6, BorderLayout.NORTH);
    jPanel7.add(autoX,  BorderLayout.NORTH);
    jPanel7.add(jPanel8,  BorderLayout.SOUTH);
    jPanel8.add(customX,  BorderLayout.WEST);
    jPanel8.add(jPanel9,  BorderLayout.CENTER);
    jPanel9.add(xFrom,  BorderLayout.WEST);
    jPanel9.add(jPanel10,  BorderLayout.CENTER);
    jPanel10.add(xToLabel,  BorderLayout.WEST);
    jPanel10.add(jPanel11,  BorderLayout.CENTER);
    jPanel11.add(xTo,  BorderLayout.CENTER);
    jPanel6.add(jPanel12,  BorderLayout.CENTER);
    jPanel12.add(autoY, BorderLayout.NORTH);
    jPanel12.add(jPanel13,  BorderLayout.SOUTH);
    jPanel13.add(customY, BorderLayout.WEST);
    jPanel13.add(jPanel14,  BorderLayout.CENTER);
    jPanel14.add(yFrom,  BorderLayout.WEST);
    jPanel14.add(jPanel15,  BorderLayout.CENTER);
    jPanel15.add(yToLabel,  BorderLayout.WEST);
    jPanel15.add(yTo,  BorderLayout.CENTER);
    diagramArea.add(jPanel16,  BorderLayout.SOUTH);
    jPanel16.add(redraw,  BorderLayout.WEST);
    jPanel16.add(jPanel19, BorderLayout.CENTER);
    jPanel19.add(exportEPS,  BorderLayout.WEST);
    jPanel19.add(jPanel20,  BorderLayout.CENTER);
    jPanel20.add(exportSrc,  BorderLayout.WEST);
    gpSourcePanel.add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(gpSrc, null);
    gpDataPanel.add(jScrollPane2, BorderLayout.CENTER);
    jScrollPane2.getViewport().add(gpData, null);
    plotPanel.add(plot, BorderLayout.CENTER);
    xrange.add(autoX);
    xrange.add(customX);
    yrange.add(autoY);
    yrange.add(customY);
    jPanel6.add(jPanel21,  BorderLayout.SOUTH);
    jPanel21.add(logY,  BorderLayout.WEST);
    jPanel21.add(ygrid, BorderLayout.EAST);
  }


  void addDS_actionPerformed(ActionEvent e) {
    AddDataSource ads = new AddDataSource (mainWindow);
    ads.setVisible(true);
    if (ads.selected!=null) {
      for (int i=0; i<ads.selected.length; i++)
        dsm.data.add(ads.selected[i]);
    }
    dsm.refresh();
    redrawPlot ();
  }

  void removeDS_actionPerformed(ActionEvent e) {
    int sure = JOptionPane.showConfirmDialog(this, "Are you sure to delete the selected rows?","Confirmation", JOptionPane.YES_NO_CANCEL_OPTION);
    if (sure==JOptionPane.YES_OPTION) {
      dsm.deleteRows (table.getSelectedRows());
      dsm.refresh();
      redrawPlot ();
    }
  }

  void runGnuPlot (String terminal, String output) {
    StringBuffer dataFile = new StringBuffer ("");
    String commandFile = "";
    String style = diagOptions.linestyle;
    String plotLine = "plot ";
    int index = 0;
    Iterator i = dsm.data.iterator();
    boolean donotredraw = true;
    while (i.hasNext()) {
      DataSource ds = (DataSource)i.next();
      if (ds.enabled.booleanValue()) {
         if (index>0)
          plotLine += ", ";
        plotLine += "'tmp/data' index " + index++  + " t '" + ds.legend + "'" + " " + style;
        dataFile.append("# " + ds.toString() + "\n");
        dataFile.append(ds.content());
        dataFile.append("\n\n");
        donotredraw = false;
      }
    }
    if (donotredraw) {
      plot.setIcon(null);
      return;
    }

    if (logX.isSelected())
      commandFile += "set logscale x\n";
    if (logY.isSelected())
      commandFile += "set logscale y\n";
    if (xgrid.isSelected())
      commandFile += "set grid xtics\n";
    if (ygrid.isSelected())
      commandFile += "set grid ytics\n";
    if (autoX.isSelected()==false)
      commandFile += "set xrange ["+xFrom.getText()+":"+xTo.getText()+"]\n";
    if (autoY.isSelected()==false)
      commandFile += "set yrange ["+yFrom.getText()+":"+yTo.getText()+"]\n";

    commandFile += diagOptions.getScriptLines();

    commandFile += plotLine + "\n";

    gpSrc.setText(commandFile);
    gpSrc.setCaretPosition(0);
    gpData.setText(dataFile.toString());
    gpData.setCaretPosition(0);

    commandFile = "set terminal " + terminal + "\nset output '"+output+"'\n" + commandFile;

    try {
      FileWriter fwd = new FileWriter ("tmp/data");
      FileWriter fws = new FileWriter ("tmp/script.gp");
      fwd.write(dataFile.toString());
      fws.write(commandFile);
      fwd.close();
      fws.close();
    }
    catch (IOException ex) {
      JOptionPane.showMessageDialog(this, ex.toString(),"Could not write gnuplot files!", JOptionPane.ERROR_MESSAGE);
    }
    try {
      Process p = Runtime.getRuntime().exec("bin/gnuplot tmp/script.gp");
      p.waitFor();
    }
    catch (IOException ex) {
      JOptionPane.showMessageDialog(this, ex.toString(),"gnuplot not found!", JOptionPane.ERROR_MESSAGE);
    }
    catch (InterruptedException ex2) {
      JOptionPane.showMessageDialog(this, ex2.toString(),"Error while executing gnuplot.exe!", JOptionPane.ERROR_MESSAGE);
    }
  }

  void redrawPlot () {

    File f = new File ("tmp/plot.gif");
    f.delete();

    runGnuPlot ("gif small size " + plot.getSize().width + "," + plot.getSize().height, "tmp/plot.gif");

    plot.setIcon(null);
    try {
      FileImageInputStream fiis = new FileImageInputStream(new File("tmp/plot.gif"));
      BufferedImage bi = ImageIO.read(fiis);
      plot.setIcon(new ImageIcon (bi));
    }
    catch (IOException ex) {
    }
  }

  void redraw_actionPerformed(ActionEvent e) {
    redrawPlot ();
  }

  void this_componentResized(ComponentEvent e) {
    redrawPlot ();
  }

  void logX_actionPerformed(ActionEvent e) {
    redrawPlot ();
  }

  void logY_actionPerformed(ActionEvent e) {
    redrawPlot ();
  }

  void refreshRange () {
    boolean ax = autoX.isSelected();
    boolean ay = autoY.isSelected();
    xFrom.setEnabled(!ax);
    xTo.setEnabled(!ax);
    xToLabel.setEnabled(!ax);
    yFrom.setEnabled(!ay);
    yTo.setEnabled(!ay);
    yToLabel.setEnabled(!ay);
  }

  void autoX_itemStateChanged(ItemEvent e) {
    refreshRange ();
  }

  void customX_itemStateChanged(ItemEvent e) {
    refreshRange ();
  }

  void autoY_itemStateChanged(ItemEvent e) {
    refreshRange ();
  }

  void customY_itemStateChanged(ItemEvent e) {
    refreshRange ();
  }

  void moreOpt_actionPerformed(ActionEvent e) {

    diagOptions.setVisible (true);
    redrawPlot ();
  }

  void exportEPS_actionPerformed(ActionEvent e) {

    JFileChooser chooser = new JFileChooser();
    int returnVal = chooser.showSaveDialog (this);
    if (returnVal==JFileChooser.APPROVE_OPTION) {
      runGnuPlot ("postscript eps", chooser.getSelectedFile().getAbsolutePath());
    }
  }

  void exportSrc_actionPerformed(ActionEvent e) {

    redrawPlot ();
    GPExport gpex = new GPExport ();
    gpex.data = gpData.getText();
    gpex.script = gpSrc.getText();

    gpex.setVisible(true);
  }

  void load_actionPerformed(ActionEvent e) {

    JFileChooser loader = new JFileChooser ("models/");
    if (loader.showOpenDialog(this)==JFileChooser.APPROVE_OPTION) {

      try {
        BufferedReader reader = new BufferedReader (new FileReader (loader.getSelectedFile()));
        String line = reader.readLine();
        String delim = " \t\n;,:";
        int linenum = 0;
        int fieldnum = -1;
        while (line!=null) {
          StringTokenizer stk = new StringTokenizer (line, delim);
          if (stk.hasMoreTokens()) {
            String first = stk.nextToken();
            if (!first.startsWith("#")) {
              linenum ++;
              if (fieldnum==-1) {
                fieldnum = 1;
                while (stk.hasMoreTokens()) {
                  fieldnum++;
                  stk.nextToken();
                }
              }
            }
          }
          line = reader.readLine();
        }
        DataSource [] ds = new DataSource [fieldnum-1];
        for (int i=0; i<fieldnum-1; i++) {
          ds[i] = new DataSource ();
          ds[i].enabled = new Boolean (true);
          ds[i].legend = "field "+(i+1);
          ds[i].name = "field "+(i+1)+" @" + loader.getSelectedFile().getName();
          ds[i].xval = new double [linenum];
          ds[i].yval = new double [linenum];
        }
        reader.close();
        reader = new BufferedReader (new FileReader (loader.getSelectedFile()));
        line = reader.readLine();
        int ix = 0;
        while (line!=null && ix < linenum) {
          StringTokenizer stk = new StringTokenizer (line, delim);
          String first = stk.nextToken();
          if (!first.startsWith("#")) {
            double xval = Double.parseDouble(first);
            for (int j = 0; j < fieldnum - 1; j++) {
              ds[j].xval[ix] = xval;
              ds[j].yval[ix] = Double.parseDouble(stk.nextToken());
            }
            ix++;
          }
          line = reader.readLine();
        }
        reader.close();
        for (int i=0; i<ds.length; i++)
          dsm.data.add(ds[i]);
        dsm.refresh();
        redrawPlot ();
      }
      catch (IOException ex) {
        JOptionPane.showMessageDialog(this, "Data series import error!\n("+ex.toString()+")", "Error reading file!", JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  public String workspaceString () {
    StringBuffer wstring = new StringBuffer("$$$ DiagramEditor xrange=");
    if (autoX.isSelected())
      wstring.append("auto");
    else
      wstring.append(""+xFrom.getText()+";"+xTo.getText());
    if (logX.isSelected())
      wstring.append(" logscale=yes ");
    else
      wstring.append(" logscale=no ");
    wstring.append(" yrange=");
    if (autoY.isSelected())
      wstring.append("auto");
    else
      wstring.append(""+yFrom.getText()+";"+yTo.getText());
    if (logY.isSelected())
      wstring.append(" logscale=yes ");
    else
      wstring.append(" logscale=no ");

    wstring.append("\n");
    Iterator i = dsm.data.iterator();
    while (i.hasNext()) {
      DataSource dsrc = (DataSource)i.next();
      wstring.append(dsrc.exportString ());
    }
    return wstring.toString();
  }

  public void importFromString (String ccline, String istring) {

    StringTokenizer stk = new StringTokenizer (ccline, "$ \t=:\n");
    String token = stk.nextToken();
    token = stk.nextToken(); // xrange=
    token = stk.nextToken();
    if (token.equals("auto")) {
      autoX.setSelected(true);
      customX.setSelected(false);
    }
    else {
      autoX.setSelected(false);
      customX.setSelected(true);
      xFrom.setText(stk.nextToken());
      xTo.setText(stk.nextToken());
    }
    token = stk.nextToken(); // logscale=
    logX.setSelected(stk.nextToken().equals("yes"));
    token = stk.nextToken(); // yrange=
    token = stk.nextToken();
    if (token.equals("auto")) {
      autoY.setSelected(true);
      customY.setSelected(false);
    }
    else {
      autoY.setSelected(false);
      customY.setSelected(true);
      yFrom.setText(stk.nextToken());
      yTo.setText(stk.nextToken());
      token = stk.nextToken(); // logscale=
      logY.setSelected(stk.nextToken().equals("yes"));
    }

    try {
      BufferedReader reader = new BufferedReader(new StringReader(istring));
      String line = reader.readLine();
      while (line != null) {
        while (line != null && line.startsWith("$$") == false)
          line = reader.readLine();
        if (line == null)
          break;
        if (line.startsWith("$$ DataSource")) {
          DataSource ds = new DataSource ();
          StringTokenizer stk2 = new StringTokenizer (line, "\"");
          String tok = stk2.nextToken();
          ds.legend = stk2.nextToken () ;
          tok = stk2.nextToken();
          ds.name = stk2.nextToken () ;
          tok = stk2.nextToken("= \"");
          ds.enabled = new Boolean (stk2.nextToken().equals("true"));
          Vector xs = new Vector ();
          Vector ys = new Vector ();
          line = reader.readLine();
          while (line != null && line.startsWith("$$") == false) {
            StringTokenizer st = new StringTokenizer (line, " \t\n");
            if (st.countTokens()<2) {
              line = reader.readLine();
              continue;
            }
            xs.add(new Double (Double.parseDouble(st.nextToken())));
            ys.add(new Double (Double.parseDouble(st.nextToken())));
            line = reader.readLine();
          }
          ds.xval = new double[xs.size()];
          ds.yval = new double[ys.size()];
          for (int i=0; i<xs.size(); i++) {
            ds.xval[i] = ((Double)xs.elementAt(i)).doubleValue();
            ds.yval[i] = ((Double)ys.elementAt(i)).doubleValue();
          }
          dsm.data.add(ds);
        }
        else
          line = reader.readLine();
      }
      reader.close();
    }
    catch (IOException ex) {

    }
    dsm.refresh();
    redrawPlot ();
  }

  void xgrid_actionPerformed(ActionEvent e) {
    redrawPlot ();
  }

  void ygrid_actionPerformed(ActionEvent e) {
    redrawPlot ();
  }
}

class DiagramEditor_addDS_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_addDS_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.addDS_actionPerformed(e);
  }
}

class DiagramEditor_removeDS_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_removeDS_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.removeDS_actionPerformed(e);
  }
}

class DiagramEditor_redraw_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_redraw_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.redraw_actionPerformed(e);
  }
}

class DiagramEditor_this_componentAdapter extends java.awt.event.ComponentAdapter {
  DiagramEditor adaptee;

  DiagramEditor_this_componentAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void componentResized(ComponentEvent e) {
    adaptee.this_componentResized(e);
  }
}

class DiagramEditor_logX_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_logX_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.logX_actionPerformed(e);
  }
}

class DiagramEditor_logY_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_logY_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.logY_actionPerformed(e);
  }
}

class DiagramEditor_autoX_itemAdapter implements java.awt.event.ItemListener {
  DiagramEditor adaptee;

  DiagramEditor_autoX_itemAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.autoX_itemStateChanged(e);
  }
}

class DiagramEditor_customX_itemAdapter implements java.awt.event.ItemListener {
  DiagramEditor adaptee;

  DiagramEditor_customX_itemAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.customX_itemStateChanged(e);
  }
}

class DiagramEditor_autoY_itemAdapter implements java.awt.event.ItemListener {
  DiagramEditor adaptee;

  DiagramEditor_autoY_itemAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.autoY_itemStateChanged(e);
  }
}

class DiagramEditor_customY_itemAdapter implements java.awt.event.ItemListener {
  DiagramEditor adaptee;

  DiagramEditor_customY_itemAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.customY_itemStateChanged(e);
  }
}

class DiagramEditor_moreOpt_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_moreOpt_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.moreOpt_actionPerformed(e);
  }
}

class DiagramEditor_exportEPS_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_exportEPS_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.exportEPS_actionPerformed(e);
  }
}

class DiagramEditor_exportSrc_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_exportSrc_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.exportSrc_actionPerformed(e);
  }
}

class DiagramEditor_load_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_load_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.load_actionPerformed(e);
  }
}

class DiagramEditor_xgrid_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_xgrid_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.xgrid_actionPerformed(e);
  }
}

class DiagramEditor_ygrid_actionAdapter implements java.awt.event.ActionListener {
  DiagramEditor adaptee;

  DiagramEditor_ygrid_actionAdapter(DiagramEditor adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ygrid_actionPerformed(e);
  }
}
