
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.stream.*;
import javax.imageio.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class DotRunner extends JDialog {
  JPanel jPanel1 = new JPanel();
  JButton abort = new JButton();
  JLabel jLabel1 = new JLabel();
  CommandRunner dotProcess = null;
  JFrame parent;

  boolean aborted;
  String cline;
  String ofile;

  public DotRunner(JFrame parent, String commandLine, String outfile) throws HeadlessException {
    super (parent);
    this.parent = parent;
    cline = commandLine;
    ofile = outfile;
    try {
      jbInit();
      setSize (500,120);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void runDot () {
    setVisible (true);
    aborted = false;
    RunDot rd = new RunDot (this, cline);
    rd.start();
  }

  public void finished () {
    setVisible (false);
    if (!aborted) {
      try {
        FileImageInputStream fiis = new FileImageInputStream(new File(ofile));
        BufferedImage bi = ImageIO.read(fiis);

        ImageIcon i = new ImageIcon(bi);
        IconDialog id = new IconDialog(parent, "States", 500, 400);
        id.showIcon(i);
      }
      catch (IOException ex) {
      }
    }
  }

  private void jbInit() throws Exception {
    this.setTitle("Drawing Graph...");
    abort.setText("Abort");
    abort.addActionListener(new DotRunner_abort_actionAdapter(this));
    jLabel1.setRequestFocusEnabled(true);
    jLabel1.setHorizontalAlignment(SwingConstants.CENTER);
    jLabel1.setHorizontalTextPosition(SwingConstants.CENTER);
    jLabel1.setText("Drawing the state space may take a while, especially if there are " +
    "more than 20 states!");
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(abort, null);
    this.getContentPane().add(jLabel1, BorderLayout.CENTER);
  }

  void abort_actionPerformed(ActionEvent e) {
    if (dotProcess!=null) {
      dotProcess.abort();
      aborted = true;
      setVisible(false);
    }
  }
}

class RunDot extends Thread {

  private String cline;
  private DotRunner parent;

  public RunDot (DotRunner parent, String commandLine) {
    this.parent = parent;
    cline = commandLine;
  }

  public void run () {
    CommandRunner cmd = new CommandRunner (cline);
    cmd.start();
    while (!cmd.running) {}
    parent.dotProcess = cmd;
    while (cmd.running) {
      try {
        sleep (200);
      }
      catch (InterruptedException ex2) {}
    }
    parent.finished ();
  }
}

class DotRunner_abort_actionAdapter implements java.awt.event.ActionListener {
  DotRunner adaptee;

  DotRunner_abort_actionAdapter(DotRunner adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.abort_actionPerformed(e);
  }
}
