
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class EditDescription extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton ok = new JButton();
  JButton cancel = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTextArea descr = new JTextArea();

  String description = null;

  public EditDescription(String d) throws HeadlessException {
    try {
      jbInit();
      descr.setText(d);
      setSize (350, 350);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setModal(true);
    this.setTitle("Edit Model Description...");
    this.getContentPane().setLayout(borderLayout1);
    ok.setText("OK");
    ok.addActionListener(new EditDescription_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new EditDescription_cancel_actionAdapter(this));
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    jPanel1.add(cancel, null);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(descr, null);
  }

  void ok_actionPerformed(ActionEvent e) {
    description = descr.getText();
    setVisible (false);
  }

  void cancel_actionPerformed(ActionEvent e) {
    description = null;
    setVisible (false);
  }

}

class EditDescription_ok_actionAdapter implements java.awt.event.ActionListener {
  EditDescription adaptee;

  EditDescription_ok_actionAdapter(EditDescription adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class EditDescription_cancel_actionAdapter implements java.awt.event.ActionListener {
  EditDescription adaptee;

  EditDescription_cancel_actionAdapter(EditDescription adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
