
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.io.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class GPExport extends JDialog {
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  GridLayout gridLayout1 = new GridLayout();
  JPanel jPanel3 = new JPanel();
  JPanel jPanel4 = new JPanel();
  JLabel jLabel1 = new JLabel();
  JTextField dataFile = new JTextField();
  JButton selectData = new JButton();
  JLabel jLabel2 = new JLabel();
  JTextField scriptFile = new JTextField();
  JButton selectScript = new JButton();
  JButton ok = new JButton();
  JButton cancel = new JButton();

  String data = "";
  String script = "";

  public GPExport() throws HeadlessException {
    try {

      setSize (430, 130);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);

      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jPanel1.setLayout(gridLayout1);
    gridLayout1.setRows(2);
    jLabel1.setText("Path to Data File:");
    selectData.setText("Select...");
    selectData.addActionListener(new GPExport_selectData_actionAdapter(this));
    jLabel2.setText("Path to Script File:");
    selectScript.setText("Select...");
    selectScript.addActionListener(new GPExport_selectScript_actionAdapter(this));
    ok.setText("OK");
    ok.addActionListener(new GPExport_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new GPExport_cancel_actionAdapter(this));
    dataFile.setText("");
    dataFile.setColumns(20);
    scriptFile.setText("");
    scriptFile.setColumns(20);
    this.setModal(true);
    this.setTitle("Export Plot...");
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel1.add(jPanel3, null);
    jPanel3.add(jLabel1, null);
    jPanel3.add(dataFile, null);
    jPanel3.add(selectData, null);
    jPanel1.add(jPanel4, null);
    jPanel4.add(jLabel2, null);
    jPanel4.add(scriptFile, null);
    jPanel4.add(selectScript, null);
    this.getContentPane().add(jPanel2,  BorderLayout.SOUTH);
    jPanel2.add(ok, null);
    jPanel2.add(cancel, null);
  }

  void cancel_actionPerformed(ActionEvent e) {

    setVisible (false);
  }

  void ok_actionPerformed(ActionEvent e) {

    try {
      FileWriter dw = new FileWriter(dataFile.getText());
      dw.write(data);
      dw.close();
    }
    catch (IOException ex) {
      JOptionPane.showMessageDialog(this, ex.toString(),"Cannot open selected data file!", JOptionPane.ERROR_MESSAGE);
    }

    try {
      FileWriter sw = new FileWriter(scriptFile.getText());
      sw.write(script);
      sw.close();
    }
    catch (IOException ex) {
      JOptionPane.showMessageDialog(this, ex.toString(),"Cannot open selected script file!", JOptionPane.ERROR_MESSAGE);
    }

    setVisible (false);
  }

  public void selectFile (JTextField tfield) {

    JFileChooser chooser = new JFileChooser ();
    int retval = chooser.showSaveDialog(this);
    if (retval==JFileChooser.APPROVE_OPTION)
      tfield.setText(chooser.getSelectedFile().getAbsolutePath());
  }

  void selectData_actionPerformed(ActionEvent e) {

    selectFile (dataFile);
  }

  void selectScript_actionPerformed(ActionEvent e) {

    selectFile (scriptFile);
  }

}

class GPExport_cancel_actionAdapter implements java.awt.event.ActionListener {
  GPExport adaptee;

  GPExport_cancel_actionAdapter(GPExport adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class GPExport_ok_actionAdapter implements java.awt.event.ActionListener {
  GPExport adaptee;

  GPExport_ok_actionAdapter(GPExport adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class GPExport_selectData_actionAdapter implements java.awt.event.ActionListener {
  GPExport adaptee;

  GPExport_selectData_actionAdapter(GPExport adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.selectData_actionPerformed(e);
  }
}

class GPExport_selectScript_actionAdapter implements java.awt.event.ActionListener {
  GPExport adaptee;

  GPExport_selectScript_actionAdapter(GPExport adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.selectScript_actionPerformed(e);
  }
}
