
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.html.*;
import java.awt.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class HelpDialog extends JDialog {

  ImageIcon iPrev = new ImageIcon ("images/rewind24.gif");
  ImageIcon iNext = new ImageIcon ("images/play24.gif");

  BorderLayout borderLayout1 = new BorderLayout();
  JEditorPane text = new JEditorPane();
  JToolBar jToolBar1 = new JToolBar();
  JButton prev = new JButton();
  JButton next = new JButton();
  JButton index = new JButton();
  JScrollPane jScrollPane1 = new JScrollPane();

  class Hyperactive implements HyperlinkListener {

    public void hyperlinkUpdate(HyperlinkEvent e) {
      if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
        JEditorPane pane = (JEditorPane) e.getSource();
        if (e instanceof HTMLFrameHyperlinkEvent) {
          HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
          HTMLDocument doc = (HTMLDocument)pane.getDocument();
          doc.processHTMLFrameHyperlinkEvent(evt);
        } else {
          try {
            pane.setPage(e.getURL());
          } catch (Throwable t) {
            t.printStackTrace();
          }
        }
      }
    }
  }

  public HelpDialog() throws HeadlessException {
    try {
      jbInit();
      setSize (500, 600);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);

      text.setPage("file:help/intro.html");
      text.addHyperlinkListener(new Hyperactive());
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    text.setEditable(false);
    text.setText("jEditorPane1");
    text.setContentType("text/html");
    this.getContentPane().setLayout(borderLayout1);
    index.setText("Index");
    index.addActionListener(new HelpDialog_index_actionAdapter(this));
    prev.setIcon(iPrev);
    prev.setText("");
    next.setIcon(iNext);
    next.setText("");
    this.setTitle("Help");
    this.getContentPane().add(jToolBar1,  BorderLayout.NORTH);
    jToolBar1.add(prev, null);
    jToolBar1.add(next, null);
    jToolBar1.add(index, null);
    this.getContentPane().add(jScrollPane1,  BorderLayout.CENTER);
    jScrollPane1.getViewport().add(text, null);
  }

  void index_actionPerformed(ActionEvent e) {
    try {
      text.setPage("file:help/intro.html");
    }
    catch (java.io.IOException ex) {
      JOptionPane.showMessageDialog(this, "Help file not found!", "Error!" ,JOptionPane.ERROR_MESSAGE);
    }
  }
}

class HelpDialog_index_actionAdapter implements java.awt.event.ActionListener {
  HelpDialog adaptee;

  HelpDialog_index_actionAdapter(HelpDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.index_actionPerformed(e);
  }
}
