
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class IconDialog extends JDialog implements ChangeListener {
  BorderLayout borderLayout1 = new BorderLayout();
  JScrollPane jScrollPane1 = new JScrollPane();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JSlider zoom = new JSlider();
  ImageIcon image;

  public IconDialog(JFrame parent, String title, int width, int height) throws HeadlessException {
    super (parent);
    try {
      jbInit();
      setSize (width, height);
      this.setTitle(title);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void showIcon (ImageIcon i) {
    image = i;
    changeImage (100);
    zoom.getModel().setMaximum(100);
    zoom.getModel().setMinimum(1);
    zoom.getModel().setValue(100);
    zoom.getModel().addChangeListener(this);
    setVisible (true);
  }

  public void changeImage (int scale) {
    int width = image.getIconWidth();
    int height = image.getIconHeight();
    Image scaledimage = image.getImage().getScaledInstance(width*scale/100, height*scale/100, Image.SCALE_SMOOTH);
    JLabel iconLabel = new JLabel (new ImageIcon (scaledimage));
    jScrollPane1.getViewport().removeAll();
    jScrollPane1.getViewport().add(iconLabel, null);
  }

  public void stateChanged (ChangeEvent e) {
    if (!zoom.getValueIsAdjusting()) {
      int scale = zoom.getModel().getValue();
      changeImage(scale);
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    jLabel1.setText("Zoom:");
    jPanel1.setLayout(borderLayout2);
    this.setModal(true);
    this.getContentPane().add(jScrollPane1, BorderLayout.CENTER);
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(jLabel1,  BorderLayout.WEST);
    jPanel1.add(zoom, BorderLayout.CENTER);
  }

}
