import javax.swing.table.*;
import java.awt.*;
import javax.swing.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class MOMResultPanel extends JPanel {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JLabel jLabel1 = new JLabel();
  BorderLayout borderLayout2 = new BorderLayout();
  JTextField name = new JTextField();
  JScrollPane jScrollPane1 = new JScrollPane();
  JTable resultTable = new JTable();
  MomTableModel mtm = null;

  public MOMResultPanel(String name, double[][] result, String running) {
    try {
      jbInit();
      mtm = new MomTableModel (running, result);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    jLabel1.setText("Name:");
    jPanel1.setLayout(borderLayout2);
    borderLayout2.setHgap(4);
    name.setText("");
    this.add(jPanel1, BorderLayout.NORTH);
    jPanel1.add(jLabel1,  BorderLayout.WEST);
    jPanel1.add(name,  BorderLayout.CENTER);
    this.add(jScrollPane1, BorderLayout.CENTER);
    jScrollPane1.getViewport().add(resultTable, null);
  }

}

class MomTableModel extends AbstractTableModel {

  String running;
  double[][] results;

  public MomTableModel (String running, double[][] results) {
    this.running = running;
    this.results = results;
  }

  public int getColumnCount() {
    return results[0].length;
  }

  public int getRowCount() {
    return results.length;
  }

  public Object getValueAt(int row, int col) {
    return new Double(results[row][col]);
  }

  public String getColumnName (int i) {
    if (i==0)
      return running;
    else
      return ""+i+". moment";
  }

  public boolean isCellEditable (int r, int c) {
    return false;
  }
}
