import java.util.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class MRMParameterSet {

  public Vector parameters = new Vector ();

  public MRMParameterSet() {
  }

  public MRMParameterSet(MRMParameterSet ps) {
    Iterator i = ps.parameters.iterator();
    while (i.hasNext()) {
      Parameter p = (Parameter)(i.next());
      parameters.add(new Parameter(p.name, p.value));
    }
  }

  public void addParameter (Parameter p) {
    parameters.add (p);
  }

  public void addParameter (Parameter p, int i) {
    parameters.add (i, p);
  }

  public void delParameter (String name) {
    Parameter p = getParameter (name);
    parameters.remove(p);
  }

  public Parameter getParameter (String name) {
    Iterator i = parameters.iterator();
    while (i.hasNext()) {
      Parameter p = (Parameter)(i.next());
      if (p.name.equals(name))
        return p;
    }
    return null;
  }

}
