
import javax.swing.table.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.event.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class NewCTfmDistribution extends JDialog {

  MRMAnalyser myAnalyser = null;
  MRM model;
  MRMParameterSet ps;
  BorderLayout borderLayout1 = new BorderLayout();
  JLabel jLabel4 = new JLabel();
  JPanel felso = new JPanel();
  JPanel jPanel4 = new JPanel();
  JLabel atLabel = new JLabel();
  JLabel fromlabel = new JLabel();
  JPanel jPanel3 = new JPanel();
  BorderLayout borderLayout8 = new BorderLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel5 = new JPanel();
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel8 = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JTextField steps = new JTextField();
  JTextField from = new JTextField();
  BorderLayout borderLayout3 = new BorderLayout();
  JTextField dsname = new JTextField();
  JPanel jPanel7 = new JPanel();
  JTextField to = new JTextField();
  JPanel jPanel6 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JLabel jLabel6 = new JLabel();
  BorderLayout borderLayout6 = new BorderLayout();
  JScrollPane scroll = new JScrollPane();
  JLabel jLabel5 = new JLabel();
  JTextField point = new JTextField();
  Border border1;
  TitledBorder titledBorder1;
  JPanel jPanel1 = new JPanel();
  JButton ok = new JButton();
  JButton cancel = new JButton();

  class ParamTableModel extends AbstractTableModel {

    public int getColumnCount() { return 2; }

    public int getRowCount() { return ps.parameters.size(); }

    public Object getValueAt(int row, int col) {
      Parameter p;
       p = (Parameter)ps.parameters.elementAt(row);
       if (col==0)
         return p.name;
       else
         return new Double(p.value);
    }

    public void setValueAt(Object val, int row, int col) {
      Parameter p;
      p = (Parameter)ps.parameters.elementAt(row);
      p.value = Double.parseDouble(val.toString());
    }

    public String getColumnName (int i) {
      if (i==0)
        return "Parameter";
      else
        return "Value";
    }

    public boolean isCellEditable (int r, int c) {
      return c==1;
    }

  }

  ParamTableModel ptm = new ParamTableModel ();
  Border border2;
  Border border3;
  JTable paramTable = new JTable();
  JCheckBox normalized = new JCheckBox();
  JPanel jPanel9 = new JPanel();
  BorderLayout borderLayout9 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JSpinner numOfMoments = new JSpinner();

  public NewCTfmDistribution() throws HeadlessException {
    try {
      jbInit();
      model = null;
      ps = new MRMParameterSet();
      setTitle("Distribution of the Completion Time");
      atLabel.setText("Of Reward =");
      fromlabel.setText("Time runs from:");
      dsname.setText("Distribution of the Completion Time");
      paramTable.setModel(ptm);
      setSize(450, 350);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation( (screen.width - mine.width) / 2,
                   (screen.height - mine.height) / 2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public NewCTfmDistribution(MRMAnalyser mrma) throws HeadlessException {
    super (mrma.model.mw);
    try {
      jbInit();
      myAnalyser = mrma;
      model = mrma.model;
      ps = model.getParameterSet();
      setTitle("Distribution of the Completion Time");
      atLabel.setText("Of Reward =");
      fromlabel.setText("Time runs from:");
      dsname.setText("Distribution of the Completion Time");
      paramTable.setModel(ptm);
      setSize(450, 350);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation( (screen.width - mine.width) / 2,
                  (screen.height - mine.height) / 2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    border1 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border1,"Value of Constants");
    border2 = BorderFactory.createEmptyBorder(4,4,4,4);
    border3 = BorderFactory.createEmptyBorder(4,4,4,4);
    felso.setLayout(borderLayout2);
    jLabel4.setText("To:");
    this.getContentPane().setLayout(borderLayout1);
    jPanel4.setLayout(borderLayout4);
    atLabel.setText("Running Parameter:");
    fromlabel.setText("Runs From:");
    jPanel3.setLayout(borderLayout3);
    borderLayout4.setHgap(4);
    borderLayout4.setVgap(4);
    jPanel2.setLayout(borderLayout6);
    borderLayout7.setHgap(4);
    jPanel8.setLayout(borderLayout8);
    borderLayout2.setHgap(4);
    borderLayout2.setVgap(4);
    steps.setText("");
    steps.setColumns(5);
    from.setText("");
    from.setColumns(5);
    from.addFocusListener(new NewCTfmDistribution_from_focusAdapter(this));
    borderLayout3.setHgap(4);
    jPanel7.setLayout(borderLayout7);
    to.setOpaque(true);
    to.setText("");
    to.setColumns(5);
    to.addFocusListener(new NewCTfmDistribution_to_focusAdapter(this));
    jPanel6.setLayout(borderLayout5);
    borderLayout5.setHgap(4);
    jLabel6.setText("Name of Data Series:");
    borderLayout6.setHgap(8);
    jLabel5.setText("Steps:");
    point.setText("");
    scroll.setBorder(titledBorder1);
    scroll.setPreferredSize(new Dimension(100, 100));
    ok.setText("OK");
    ok.addActionListener(new NewCTfmDistribution_ok_actionAdapter(this));
    cancel.setText("Cancel");
    cancel.addActionListener(new NewCTfmDistribution_cancel_actionAdapter(this));
    this.setModal(true);
    borderLayout1.setHgap(0);
    borderLayout1.setVgap(0);
    jPanel3.setBorder(border2);
    jPanel4.setBorder(border3);
    normalized.setToolTipText("Compute the distribution of the average accumulated reward or the " +
    "average completion time");
    normalized.setVerifyInputWhenFocusTarget(true);
    normalized.setText("Normalize distribution");
    jPanel9.setLayout(borderLayout9);
    jLabel1.setBackground(Color.orange);
    jLabel1.setText("Num. of moments to use:");
    jPanel3.add(atLabel, BorderLayout.WEST);
    jPanel3.add(jPanel5, BorderLayout.SOUTH);
    jPanel5.add(fromlabel, null);
    jPanel5.add(from, null);
    jPanel5.add(jLabel4, null);
    jPanel5.add(to, null);
    jPanel5.add(jLabel5, null);
    jPanel5.add(steps, null);
    felso.add(jPanel4, BorderLayout.SOUTH);
    felso.add(jPanel3, BorderLayout.NORTH);
    jPanel6.add(jLabel6, BorderLayout.WEST);
    jPanel6.add(dsname, BorderLayout.CENTER);
    jPanel4.add(jPanel2, BorderLayout.NORTH);
    jPanel4.add(jPanel6, BorderLayout.SOUTH);
    jPanel2.add(jPanel8, BorderLayout.EAST);
    jPanel8.add(normalized, BorderLayout.CENTER);
    felso.add(scroll, BorderLayout.CENTER);
    scroll.getViewport().add(paramTable, null);
    this.getContentPane().add(jPanel1,  BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    jPanel1.add(cancel, null);
    jPanel2.add(jPanel7, BorderLayout.CENTER);
    this.getContentPane().add(felso, BorderLayout.CENTER);
    jPanel3.add(point,  BorderLayout.CENTER);
    jPanel9.add(jLabel1, java.awt.BorderLayout.WEST);
    jPanel9.add(numOfMoments, java.awt.BorderLayout.CENTER);
    jPanel7.add(jPanel9, java.awt.BorderLayout.CENTER);
    numOfMoments.setValue(new Integer(17));
  }

  void generateLabel () {
    String label;
    dsname.setText("Estimated Distribution of the Completion Time, Reward="+point.getText());
  }


  void from_focusLost(FocusEvent e) {
    generateLabel ();
  }

  void to_focusLost(FocusEvent e) {
    generateLabel ();
  }

  void ok_actionPerformed(ActionEvent e) {
    // generate parametersets to analyse:
    String error = "'From'";
    try {
      double vfrom = Double.parseDouble(from.getText());
      error = "'To'";
      double vto = Double.parseDouble(to.getText());
      error = "'Steps'";
      int vstep = Integer.parseInt(steps.getText());
      error = "'Point'";
      double vx = Double.parseDouble(point.getText());

      String[] ylabels = new String [4];
      ylabels[0] = "cdf (upper)";
      ylabels[1] = "cdf (lower)";
      ylabels[2] = "ccdf (upper)";
      ylabels[3] = "ccdf (lower)";

      String runs = "Time";
      MRMParameterSet pps = new MRMParameterSet (ps);
      DataSeries ds = new DataSeries(pps, dsname.getText(), runs, ylabels);
      ds.label.setText(dsname.getText());
      ds.momentType = false;
      ds.quantity = "completion time";
      myAnalyser.addDataSeries(ds);
      AnalysisRunner ar = new AnalysisRunner(myAnalyser, ds);
      ar.executeCTfmDistributionAnalysis(vx, vfrom, vto, vstep, normalized.isSelected(), ((Integer)numOfMoments.getValue()).intValue());
      setVisible(false);
    }
    catch (NumberFormatException ex) {
      JOptionPane.showMessageDialog(this, "Illegal number format at field "+error+"!", "Bad number format!", JOptionPane.ERROR_MESSAGE);
    }
  }

  void cancel_actionPerformed(ActionEvent e) {
    setVisible (false);
  }
}

class NewCTfmDistribution_from_focusAdapter extends java.awt.event.FocusAdapter {
  NewCTfmDistribution adaptee;

  NewCTfmDistribution_from_focusAdapter(NewCTfmDistribution adaptee) {
    this.adaptee = adaptee;
  }
  public void focusLost(FocusEvent e) {
    adaptee.from_focusLost(e);
  }
}

class NewCTfmDistribution_to_focusAdapter extends java.awt.event.FocusAdapter {
  NewCTfmDistribution adaptee;

  NewCTfmDistribution_to_focusAdapter(NewCTfmDistribution adaptee) {
    this.adaptee = adaptee;
  }
  public void focusLost(FocusEvent e) {
    adaptee.to_focusLost(e);
  }
}

class NewCTfmDistribution_ok_actionAdapter implements java.awt.event.ActionListener {
  NewCTfmDistribution adaptee;

  NewCTfmDistribution_ok_actionAdapter(NewCTfmDistribution adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class NewCTfmDistribution_cancel_actionAdapter implements java.awt.event.ActionListener {
  NewCTfmDistribution adaptee;

  NewCTfmDistribution_cancel_actionAdapter(NewCTfmDistribution adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}
