
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.awt.event.*;
import javax.swing.border.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class NewMRMDialog extends JDialog {

  Vector mrmTypes = new Vector ();

  BorderLayout borderLayout1 = new BorderLayout();
  JPanel buttonPanel = new JPanel();
  JPanel jPanel3 = new JPanel();
  JButton okbutton = new JButton();
  JButton cancelbutton = new JButton();
  JSplitPane jSplitPane1 = new JSplitPane();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout3 = new BorderLayout();
  JLabel jLabel1 = new JLabel();
  JScrollPane jScrollPane1 = new JScrollPane();
  JList mrmtypelist = new JList();
  JPanel jPanel2 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  JScrollPane jScrollPane2 = new JScrollPane();
  JEditorPane mrmdescription = new JEditorPane();

  public MRMType selected = null;
  public boolean useFormalizm = true;
  public String name = null;
  public String description = null;

  JPanel jPanel4 = new JPanel();
  JLabel jLabel3 = new JLabel();
  JTextField mname = new JTextField();
  GridLayout gridLayout1 = new GridLayout();
  JRadioButton formalizm = new JRadioButton();
  JRadioButton raw = new JRadioButton();
  JPanel jPanel5 = new JPanel();
  JPanel jPanel6 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  Border border1;
  TitledBorder titledBorder1;
  JButton intro = new JButton();
  JPanel jPanel7 = new JPanel();
  JPanel jPanel8 = new JPanel();
  BorderLayout borderLayout6 = new BorderLayout();
  ButtonGroup defmodel = new ButtonGroup();

  public NewMRMDialog(Vector mrmTypes, String defname) throws HeadlessException {
    try {
      jbInit();
      mname.setText(defname);
      mname.selectAll();
      mname.requestFocus();

      this.mrmTypes = mrmTypes;
      mrmtypelist.setListData(mrmTypes);
      mrmtypelist.setSelectedIndex(0);
      setSize (440,400);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED,Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border1,"Type of model description:");
    this.setForeground(Color.black);
    this.setModal(true);
    this.setTitle("New MRM...");
    this.getContentPane().setLayout(borderLayout1);
    okbutton.setText("OK");
    okbutton.addActionListener(new NewMRMDialog_okbutton_actionAdapter(this));
    cancelbutton.setText("Cancel");
    cancelbutton.addActionListener(new NewMRMDialog_cancelbutton_actionAdapter(this));
    jPanel3.setLayout(borderLayout2);
    jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
    jSplitPane1.setLastDividerLocation(110);
    jPanel1.setLayout(borderLayout3);
    jLabel1.setText("Type of Reward Model:");
    jPanel2.setLayout(borderLayout4);
    jLabel2.setRequestFocusEnabled(true);
    jLabel2.setText("Model Description:");
    mrmtypelist.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    jScrollPane1.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
    mrmdescription.setText("");
    mrmdescription.setContentType("text/plain");
    jLabel3.setText("Model name:");
    mname.setText("");
    mname.setColumns(25);
    formalizm.setText("Use formalizm");
    formalizm.setSelected(true);
    raw.setText("Use raw data");
    jPanel5.setLayout(gridLayout1);
    jPanel5.setBorder(titledBorder1);
    jPanel4.setLayout(borderLayout5);
    intro.setHorizontalAlignment(SwingConstants.CENTER);
    intro.setText("Short Description of Selected MRM Type...");
    intro.addActionListener(new NewMRMDialog_intro_actionAdapter(this));
    buttonPanel.setLayout(borderLayout6);
    this.getContentPane().add(buttonPanel, BorderLayout.SOUTH);
    this.getContentPane().add(jPanel3, BorderLayout.CENTER);
    buttonPanel.add(jPanel8,  BorderLayout.WEST);
    jPanel8.add(intro, null);
    buttonPanel.add(jPanel7,  BorderLayout.EAST);
    jPanel7.add(okbutton, null);
    jPanel7.add(cancelbutton, null);
    jPanel3.add(jSplitPane1,  BorderLayout.CENTER);
    jSplitPane1.add(jPanel2, JSplitPane.TOP);
    jPanel1.add(jLabel1, BorderLayout.NORTH);
    jPanel1.add(jScrollPane1,  BorderLayout.CENTER);
    jSplitPane1.add(jPanel1, JSplitPane.BOTTOM);
    jPanel2.add(jLabel2, BorderLayout.NORTH);
    jPanel2.add(jScrollPane2, BorderLayout.CENTER);
    jPanel3.add(jPanel4, BorderLayout.NORTH);
    jPanel5.add(formalizm, null);
    jPanel5.add(raw, null);
    jPanel4.add(jPanel6, BorderLayout.NORTH);
    jPanel6.add(jLabel3, null);
    jPanel6.add(mname, null);
    jPanel4.add(jPanel5,  BorderLayout.CENTER);
    jScrollPane2.getViewport().add(mrmdescription, null);
    jScrollPane1.getViewport().add(mrmtypelist, null);
    jSplitPane1.setDividerLocation(100);
    defmodel.add(formalizm);
    defmodel.add(raw);
  }

  void cancelbutton_actionPerformed(ActionEvent e) {
    setVisible(false);
  }

  void okbutton_actionPerformed(ActionEvent e) {
    int i = mrmtypelist.getSelectedIndex();
    if (i>=0) {
      selected = (MRMType)mrmTypes.elementAt(i);
      description = mrmdescription.getText();
      useFormalizm = formalizm.isSelected();
      if (useFormalizm)
        name = mname.getText()+".frm";
      else
        name = mname.getText()+".rrm";
    }
    setVisible (false);
  }

  void intro_actionPerformed(ActionEvent e) {
    int i = mrmtypelist.getSelectedIndex();
    if (i>=0) {
      HTMLDialog htmlDialog = new HTMLDialog ("Introduction", 300, 400);
      htmlDialog.showString(((MRMType)mrmTypes.elementAt(i)).getDescription());
    }
  }

}

class NewMRMDialog_cancelbutton_actionAdapter implements java.awt.event.ActionListener {
  NewMRMDialog adaptee;

  NewMRMDialog_cancelbutton_actionAdapter(NewMRMDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancelbutton_actionPerformed(e);
  }
}

class NewMRMDialog_okbutton_actionAdapter implements java.awt.event.ActionListener {
  NewMRMDialog adaptee;

  NewMRMDialog_okbutton_actionAdapter(NewMRMDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.okbutton_actionPerformed(e);
  }
}

class NewMRMDialog_intro_actionAdapter implements java.awt.event.ActionListener {
  NewMRMDialog adaptee;

  NewMRMDialog_intro_actionAdapter(NewMRMDialog adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.intro_actionPerformed(e);
  }
}
