
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.util.*;
import javax.swing.table.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.beans.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class NewMomentSeries extends JDialog {
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel1 = new JPanel();
  JButton cancel = new JButton();
  JButton ok = new JButton();
  JPanel felso = new JPanel();
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel jPanel3 = new JPanel();
  JLabel jLabel1 = new JLabel();
  BorderLayout borderLayout3 = new BorderLayout();
  JComboBox running = new JComboBox();
  Border border1;
  JPanel jPanel4 = new JPanel();
  BorderLayout borderLayout4 = new BorderLayout();
  JLabel jLabel2 = new JLabel();
  JSpinner momnum = new JSpinner();
  Border border2;
  JScrollPane scroll = new JScrollPane();
  JTable paramTable = new JTable();
  Border border3;
  TitledBorder titledBorder1;
  JPanel jPanel5 = new JPanel();
  JLabel jLabel3 = new JLabel();
  JTextField from = new JTextField();
  JLabel jLabel4 = new JLabel();
  JTextField to = new JTextField();
  JLabel jLabel5 = new JLabel();
  JTextField steps = new JTextField();
  MRMAnalyser myAnalyser = null;
  boolean isAR;

  Integer numOfMoms = new Integer (5);
  MRM model;
  MRMParameterSet ps;
  JPanel jPanel6 = new JPanel();
  BorderLayout borderLayout5 = new BorderLayout();
  JLabel jLabel6 = new JLabel();
  JTextField dsname = new JTextField();

  class ParamTableModel extends AbstractTableModel {

    public int getColumnCount() { return 2; }

    public int getRowCount() { return ps.parameters.size()-1; }

    public Object getValueAt(int row, int col) {
      Parameter p;
      if (running.getSelectedIndex()<=row)
        p = (Parameter)ps.parameters.elementAt(row+1);
      else
        p = (Parameter)ps.parameters.elementAt(row);
      if (col==0)
        return p.name;
      else
        return new Double(p.value);
    }

    public void setValueAt(Object val, int row, int col) {
      Parameter p;
      if (running.getSelectedIndex()<=row)
        p = (Parameter)ps.parameters.elementAt(row+1);
      else
        p = (Parameter)ps.parameters.elementAt(row);
      p.value = Double.parseDouble(val.toString());
    }

    public String getColumnName (int i) {
      if (i==0)
        return "Parameter";
      else
        return "Value";
    }

    public boolean isCellEditable (int r, int c) {
      return c==1;
    }

  }


  public NewMomentSeries(MRMAnalyser mrma, boolean isAR) throws HeadlessException {
    super (mrma.model.mw);
    myAnalyser = mrma;
    model = mrma.model;
    this.isAR = isAR;
    try {
      jbInit();
      ps = model.getParameterSet();
      if (isAR) {
        ps.addParameter(new Parameter ("Time",1.0), 0);
        dsname.setText("AR Moments vs. Time");
      }
      else {
        ps.addParameter(new Parameter ("Reward",1.0), 0);
        dsname.setText("CT Moments vs. Reward");
      }
      paramTable.setModel(ptm);
      momnum.setValue(numOfMoms);
      setSize (360,350);
      Dimension screen = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
      Dimension mine = getSize();
      setLocation ((screen.width-mine.width)/2, (screen.height-mine.height)/2);
      fillParameterTable ();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }

  public void fillParameterTable () {
    Iterator i = ps.parameters.iterator();
    while (i.hasNext()) {
      Parameter p = (Parameter)(i.next());
      running.addItem(p.name);
    }
    running.setSelectedIndex(0);
  }

  ParamTableModel ptm = new ParamTableModel ();
  JPanel jPanel2 = new JPanel();
  JPanel jPanel7 = new JPanel();
  BorderLayout borderLayout6 = new BorderLayout();
  BorderLayout borderLayout7 = new BorderLayout();
  JPanel jPanel8 = new JPanel();
  JCheckBox normalized = new JCheckBox();
  BorderLayout borderLayout8 = new BorderLayout();

  private void jbInit() throws Exception {
    border1 = BorderFactory.createEmptyBorder(4,4,4,4);
    border2 = BorderFactory.createEmptyBorder(4,4,4,4);
    border3 = BorderFactory.createEtchedBorder(Color.white,new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(border3,"Value of Constants");
    this.setModal(true);
    this.setTitle("Create Data Series from Moments");
    this.getContentPane().setLayout(borderLayout1);
    cancel.setText("Cancel");
    cancel.addActionListener(new NewMomentSeries_cancel_actionAdapter(this));
    ok.setText("OK");
    ok.addActionListener(new NewMomentSeries_ok_actionAdapter(this));
    felso.setLayout(borderLayout2);
    jLabel1.setText("Running Parameter:");
    jPanel3.setLayout(borderLayout3);
    borderLayout2.setHgap(4);
    borderLayout2.setVgap(4);
    jPanel3.setBorder(border1);
    borderLayout3.setHgap(4);
    jPanel4.setLayout(borderLayout4);
    borderLayout4.setHgap(4);
    borderLayout4.setVgap(4);
    jLabel2.setText("Number of Moments to Compute:");
    jPanel4.setBorder(border2);
    scroll.setBorder(titledBorder1);
    jLabel3.setText("Runs From:");
    from.setText("");
    from.setColumns(5);
    from.addFocusListener(new NewMomentSeries_from_focusAdapter(this));
    jLabel4.setText("To:");
    to.setOpaque(true);
    to.setText("");
    to.setColumns(5);
    to.addFocusListener(new NewMomentSeries_to_focusAdapter(this));
    jLabel5.setText("Steps:");
    steps.setText("");
    steps.setColumns(5);
    jPanel6.setLayout(borderLayout5);
    jLabel6.setText("Name of Data Series:");
    borderLayout5.setHgap(4);
    running.addItemListener(new NewMomentSeries_running_itemAdapter(this));
    jPanel2.setLayout(borderLayout6);
    jPanel7.setLayout(borderLayout7);
    normalized.setText("normalized");
    jPanel8.setLayout(borderLayout8);
    borderLayout6.setHgap(8);
    borderLayout7.setHgap(4);
    this.getContentPane().add(jPanel1, BorderLayout.SOUTH);
    jPanel1.add(ok, null);
    jPanel1.add(cancel, null);
    this.getContentPane().add(felso, BorderLayout.CENTER);
    felso.add(jPanel3, BorderLayout.NORTH);
    jPanel3.add(jLabel1,  BorderLayout.WEST);
    jPanel3.add(running, BorderLayout.CENTER);
    jPanel3.add(jPanel5,  BorderLayout.SOUTH);
    felso.add(jPanel4, BorderLayout.SOUTH);
    jPanel4.add(jPanel6,  BorderLayout.SOUTH);
    jPanel6.add(jLabel6, BorderLayout.WEST);
    jPanel6.add(dsname, BorderLayout.CENTER);
    jPanel4.add(jPanel2, BorderLayout.NORTH);
    jPanel2.add(jPanel7,  BorderLayout.CENTER);
    jPanel7.add(jLabel2,  BorderLayout.WEST);
    jPanel7.add(momnum, BorderLayout.CENTER);
    felso.add(scroll, BorderLayout.CENTER);
    scroll.getViewport().add(paramTable, null);
    jPanel5.add(jLabel3, null);
    jPanel5.add(from, null);
    jPanel5.add(jLabel4, null);
    jPanel5.add(to, null);
    jPanel5.add(jLabel5, null);
    jPanel5.add(steps, null);
    jPanel2.add(jPanel8,  BorderLayout.EAST);
    jPanel8.add(normalized, BorderLayout.CENTER);
  }



  void ok_actionPerformed(ActionEvent e) {

    // generate parametersets to analyse:
    String error = "'From'";
    try {
      double vfrom = Double.parseDouble(from.getText());
      error = "'To'";
      double vto = Double.parseDouble(to.getText());
      error = "'Steps'";
      int vstep = Integer.parseInt(steps.getText());
      String runs = running.getSelectedItem().toString();
      error = "'Num. of Moments'";
      int vmoms = ( (Integer) momnum.getValue()).intValue();

      String[] columns = new String[vmoms];
      for (int i = 0; i < vmoms; i++)
        columns[i] = "" + i + ". moment";

      MRMParameterSet pps = new MRMParameterSet (ps);
      DataSeries ds = new DataSeries(pps, dsname.getText(), runs, columns);
      ds.label.setText(dsname.getText());
      ds.momentType = true;
      ds.modelString = myAnalyser.model.saveModelToString();
      if (isAR)
        ds.quantity = "accumulated reward";
      else
        ds.quantity = "completion time";
      myAnalyser.addDataSeries(ds);
      AnalysisRunner ar = new AnalysisRunner(myAnalyser, ds);
      Parameter p = (Parameter) ps.parameters.elementAt(0);
      boolean isAR = p.name.equalsIgnoreCase("Time");
      ar.executeMomentAnalysis(vfrom, vto, vstep, normalized.isSelected(), isAR);
      setVisible(false);
    }
    catch (NumberFormatException ex) {
      JOptionPane.showMessageDialog(this, "Illegal number format at field "+error+"!", "Bad number format!", JOptionPane.ERROR_MESSAGE);
    }
  }

  void cancel_actionPerformed(ActionEvent e) {
    setVisible (false);
  }

  void generateLabel () {
    String label;
    if (isAR)
      label = "AR Moments vs. ";
    else
      label = "CT Moments vs. ";
    label += running.getSelectedItem().toString()+"="+from.getText()+".."+to.getText();
    dsname.setText(label);
  }

  void running_itemStateChanged(ItemEvent e) {
    if (e.getStateChange()==e.SELECTED) {
      TableModelEvent te = new TableModelEvent (ptm);
      paramTable.tableChanged(te);
      generateLabel ();
    }
  }

  void from_focusLost(FocusEvent e) {
    generateLabel ();
  }

  void to_focusLost(FocusEvent e) {
    generateLabel ();
  }


}

class NewMomentSeries_ok_actionAdapter implements java.awt.event.ActionListener {
  NewMomentSeries adaptee;

  NewMomentSeries_ok_actionAdapter(NewMomentSeries adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.ok_actionPerformed(e);
  }
}

class NewMomentSeries_cancel_actionAdapter implements java.awt.event.ActionListener {
  NewMomentSeries adaptee;

  NewMomentSeries_cancel_actionAdapter(NewMomentSeries adaptee) {
    this.adaptee = adaptee;
  }
  public void actionPerformed(ActionEvent e) {
    adaptee.cancel_actionPerformed(e);
  }
}

class NewMomentSeries_running_itemAdapter implements java.awt.event.ItemListener {
  NewMomentSeries adaptee;

  NewMomentSeries_running_itemAdapter(NewMomentSeries adaptee) {
    this.adaptee = adaptee;
  }
  public void itemStateChanged(ItemEvent e) {
    adaptee.running_itemStateChanged(e);
  }
}

class NewMomentSeries_from_focusAdapter extends java.awt.event.FocusAdapter {
  NewMomentSeries adaptee;

  NewMomentSeries_from_focusAdapter(NewMomentSeries adaptee) {
    this.adaptee = adaptee;
  }
  public void focusLost(FocusEvent e) {
    adaptee.from_focusLost(e);
  }
}

class NewMomentSeries_to_focusAdapter extends java.awt.event.FocusAdapter {
  NewMomentSeries adaptee;

  NewMomentSeries_to_focusAdapter(NewMomentSeries adaptee) {
    this.adaptee = adaptee;
  }
  public void focusLost(FocusEvent e) {
    adaptee.to_focusLost(e);
  }
}
