

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class Option {

  public static final int BOOL = 1;
  public static final int STRING = 2;
  public static final int DOUBLE = 3;
  public static final int CHOICE = 4;

  int type;
  String name;
  Object def;
  Object value;
  String[] choice = null;
  String description = null;

  public Option (String name, int type, Object def) {
    this.name = name;
    this.type = type;
    this.def = def;
    value = def;
  }

  public void addDescription (String descr) {
    description = descr;
  }

  public String getDescription () {
    return description;
  }

  public int getType () {
    return type;
  }

  public String getName () {
    return name;
  }

  public Object getValue () {
    return value;
  }

  public void setValue (Object val) {
    value = val;
  }

  public Object getDefault () {
    return def;
  }

  public void addChoice (String[] choice) {
    this.choice = choice;
  }

  public String[] getChoice () {
    return choice;
  }
}
