import java.util.*;

/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class PUVector extends UVector {

  public PUVector (String n, String l) {
    super (n, l);
  }

  public String check () {

    double sum = 0;
    Iterator i = val.iterator ();
    Iterator j = state.iterator ();
    while (i.hasNext()) {
      double d = ( (Double) (i.next())).doubleValue();
      int e = ( (Integer) (j.next())).intValue();
      if (d<0.0 || d>1.0)
        return name+": elements of this vector must be probabilities! (element "+e+")";
      sum += d;
    }
    if (sum==1.0)
      return null;
    else
      return name+": sum of elements must be =1!";
  }
}
