
import java.util.*;
/**
 * <p>Title: MRMSolve2</p>
 * <p>Description: The Markov Reward Model Solver</p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: BUTE Dept. of Telecommunications</p>
 * @author not attributable
 * @version 2.0
 */

public class SOPILType implements MRMType {

  Vector options = new Vector ();

  public SOPILType() {

    Option epsilon = new Option ("Epsilon", Option.DOUBLE, new Double (0.0001));
    options.add(epsilon);
    epsilon.addDescription("<html><body bgcolor=%BG%><h2>Epsilon</h2> The maximal allowed error of the randomization algorithm."+
                         "Larger value speeds up computation but decreases accuracy. This option has meaning only if algorithm is set to <i>Randomization</i>.</body></html>");
  }

  public Option[] getOptions () {
    Option[] opts = new Option[options.size()];
    Enumeration e = options.elements();
    int i = 0;
    while (e.hasMoreElements())
      opts[i++] = (Option)e.nextElement();
    return opts;
  }

  public Option getOption (String name) {
    Iterator i = options.iterator();
    while (i.hasNext()) {
      Option o = (Option)i.next();
      if (o.getName().equals(name))
        return o;
    }
    return null;
  }

  public MRM getInstance (String shname, String fname, boolean isRaw) {
    return new SOPILMRM (this, shname, fname, isRaw);
  }

  public String getMnemonic () {
    return "sopil";
  }

  public String getName () {
    return "Second Order MRM with Partial Increment Loss";
  }

  public String getDescription () {
    return "<html><body><h2>Second Order MRM with Partial Increment Loss</h2></body></html>";
  }

  public boolean canComputeARMoms () {
    return true;
  }

  public boolean canComputeCTMoms () {
    return false;
  }

  public boolean canComputeARDistr () {
    return false;
  }

  public boolean canComputeCTDistr () {
    return false;
  }

  public String toString () {
    return getName ();
  }

  public boolean canDrawStateSpace () {
    return true;
  }
}
