import javax.swing.table.AbstractTableModel;
import javax.swing.*;
import java.util.*;
import java.io.*;

public class UVector extends AbstractTableModel {

  Vector state = new Vector ();
  Vector val = new Vector ();
  int nextstate = 0;
  String label = "";
  String name = "";
  boolean dirty = false;

  public UVector (String n, String l) {
    label = l;
    name = n;
  }

  public boolean isDirty () {
    return dirty;
  }

  public void setDirty (boolean d) {
    dirty = d;
  }

  public int getColumnCount() { return 2; }

  public int getRowCount() { return state.size();}

  public String check () {
    Iterator i = val.iterator ();
    Iterator j = state.iterator ();
    while (i.hasNext()) {
      double d = ( (Double) (i.next())).doubleValue();
      int e = ( (Integer) (j.next())).intValue();
      if (d<0.0)
        return name+": elements of this vector must be non-negative! (element "+e+")";
    }
    return null;
  }

  public Object getValueAt(int row, int col) {
    if (col==0)
      return state.elementAt(row);
    else if (col==1)
      return val.elementAt(row);
    return null;
  }

  public void setValueAt(Object oval, int row, int col) {
    if (col==0) {
      int ival = Integer.parseInt(oval.toString());
      state.setElementAt(new Integer(ival), row);
      if (ival>=nextstate)
        nextstate = ival + 1;
    }
    else if (col==1)
      val.setElementAt (new Double (Double.parseDouble(oval.toString())), row);
    dirty = true;
  }

  public String getColumnName (int i) {
    if (i==0)
      return "State";
    else if (i==1)
      return label;
    return null;
  }

  public void clear () {
    state.clear();
    val.clear();
    dirty = true;
  }

  public void addLine () {
    state.add(new Integer (nextstate++));
    val.add(new Double (1.0));
    dirty = true;
  }

  public void addLine (int st, double p) {
    state.add(new Integer (st));
    val.add(new Double (p));
    dirty = true;
  }

  public void delLine (int i) {
    if (i>=0 && i<state.size ()) {
      state.remove(i);
      val.remove(i);
      dirty = true;
    }
  }

  public boolean isCellEditable (int r, int c) {
    return true;
  }

  public void load () {

    if (getRowCount()>0 && JOptionPane.showConfirmDialog(null, "When reading a file, the current vector content will be lost!\n Are you sure to continue?")!=JOptionPane.YES_OPTION)
      return;

    clear();

    JFileChooser chooser = new JFileChooser();
    int returnVal = chooser.showOpenDialog (null);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      String delim = new String (" \n\r\t,;:(){}[]-_><=");
      try {
        String fname = chooser.getSelectedFile().getAbsolutePath();
        BufferedReader file = new BufferedReader(new FileReader(fname));
        int linenum = 1;
        String line = file.readLine();
        while (line!=null) {
          StringTokenizer tk = new StringTokenizer (line, delim);
          int toknum = 1;
          try {
            int state = Integer.parseInt(tk.nextToken());
            toknum++;
            double p = Double.parseDouble(tk.nextToken());
            addLine(state, p);
          }
          catch (NoSuchElementException ex1) {
            JOptionPane.showMessageDialog(null, "In line "+linenum+": "+ex1.toString(),"Error reading file", JOptionPane.ERROR_MESSAGE);
            break;
          }
          catch (NumberFormatException ex2) {
            JOptionPane.showMessageDialog(null, "In line "+linenum+", token "+toknum+": "+ex2.toString(),"Error reading file", JOptionPane.ERROR_MESSAGE);
            break;
          }
          linenum++;
          line = file.readLine();
        }
      } catch (IOException ex) {
        JOptionPane.showMessageDialog(null, ex.toString(),"Error reading file", JOptionPane.ERROR_MESSAGE);
      }
      dirty = true;
    }
  }
}
